﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Framework
{
    public class AccessLogDALImpl : IAccessLogDAL
    {
        Linq.LinqToSqlDataContext dataContext = new Linq.LinqToSqlDataContext();
        IConfigurationDAL conf = new ConfigurationDALImpl();

        public bool InsertAccessLog(int _userId, string _action)
        {
            try
            {

                Linq.AccessLog ac = new Linq.AccessLog();

                ac.instant = DateTime.Now;
                ac.user_id = _userId;
                ac.action = _action;
                
                
                dataContext.AccessLog.InsertOnSubmit(ac);
                dataContext.SubmitChanges();

                return true;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return false;
            }
        }

        public bool InsertAccessLogSystem(string _action)
        {
            try
            {

                Linq.AccessLog ac = new Linq.AccessLog();

                ac.instant = DateTime.Now;
                ac.user_id = 0;
                ac.action = _action;

                dataContext.AccessLog.InsertOnSubmit(ac);
                dataContext.SubmitChanges();

                return true;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return false;
            }
        }

        public List<AccessLog> GetAccesLogByUserId(int _userId)
        {
            List<AccessLog> accesLog = new List<AccessLog>();

            try
            {

                var search = from _al in dataContext.AccessLog
                             where _al.user_id == _userId
                             orderby _al.instant descending
                             select _al;

                foreach (var al in search)
                {
                    AccessLog tmp = new AccessLog(al.instant, al.user_id, al.action);
                    accesLog.Add(tmp);
                }

                return accesLog;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                InsertAccessLogSystem("Error al llegir els events del ususari " + _userId);
                return null;
            }
        }

    }
}
