﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Mail;
using System.IO;

using System.Diagnostics;
using System.Configuration;
using TweetSharp;
using TweetSharp.Model;
using System.Net;


namespace Framework
{
    public class ConfigurationDALImpl : IConfigurationDAL
    {
        Linq.LinqToSqlDataContext dataContext = new Linq.LinqToSqlDataContext();

        public Configuration GetConfiguration()
        {
            try
            {

                Configuration configuration= new Configuration();

                var search = from conf in dataContext.Configuration
                             select conf;

                if (search.Count() > 0)
                {
                    if (!search.First().domainAdminUser.Equals(null))
                    {
                        configuration.DomainAdminUser = search.First().domainAdminUser.Trim();
                    }
                    if (!search.First().domainPwdUser.Equals(null))
                    {
                        configuration.DomainPwdUser = search.First().domainPwdUser.Trim();
                    }
                    if (!!search.First().domainPwdUser.Equals(null))
                    {
                        configuration.Domain = search.First().domain.Trim();
                    }
                    configuration.ServerSMTP = search.First().serverSMTP.Trim();
                    if (!search.First().userSMTP.Equals(null))
                    {
                    configuration.UserSMTP = search.First().userSMTP.Trim();
                    }
                    if (!search.First().pwdSMTP.Equals(null))
                    {
                        configuration.PwdSMTP = search.First().pwdSMTP.Trim();
                    }
                    configuration.TimeUpdate = search.First().timeUpdate;
                    configuration.MaxTimeCPU = search.First().maxTimeCPU;
                    configuration.MaxMemoryUsage = search.First().maxMemoryUsage;
                    configuration.MaxHddUsage = search.First().maxHddUsage;
                    configuration.MaxTimeOut = search.First().maxTimeOut;
                }

                writeLog("GetConfiguration OK");
                return configuration;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return null;
            }
        }

        public bool UpdateTimeUpdate(int _interval)
        {

            try
            {

                var search = from _conf in dataContext.Configuration
                             select _conf;

                if (search.Count() > 0)
                {
                    search.First().timeUpdate = _interval;
                }
                
                dataContext.SubmitChanges();

                writeLog("UpdateTimeUpdate: " + _interval);
                return true;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public int GetTimeUpdate()    
        {
            try
            {
                             
                var search = (from time in dataContext.Configuration
                             select time).First().timeUpdate;

                if (search > 0)
                    return search;

                writeLog("Error de GetTimeUpdate");
                return 0;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return -1;
            }
        }

        public bool UpdateMaxTimeCPU(int _maxTimeCPU)
        {
            try
            {
                var search = from _conf in dataContext.Configuration
                             select _conf;

                if (search.Count() > 0)
                {
                    search.First().maxTimeCPU = _maxTimeCPU;
                }

                dataContext.SubmitChanges();

                writeLog("UpdateMaxTimeUpdate");
                return true;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public int GetMaxTimeCPU()
        {

            try
            {
                var search = (from conf in dataContext.Configuration
                             select conf).First().maxTimeCPU;

                if (search > 0)
                    return search;

                writeLog("GetMaxTimeCPU");
                return 0;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return -1;
            }
        }

        public bool UpdateMaxMemoryUsage(int _maxMemoryUsage)
        {
            try
            {
                var search = from _conf in dataContext.Configuration
                             select _conf;

                if (search.Count() > 0)
                {
                    search.First().maxMemoryUsage = _maxMemoryUsage;
                }

                dataContext.SubmitChanges();

                writeLog("UpdateMaxMemoryUsage");
                return true;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public int GetMaxMemoryUsage()
        {
            try
            {
                var search = (from conf in dataContext.Configuration
                             select conf).First().maxMemoryUsage;

                if (search > 0)
                    return search;

                writeLog("GetMaxMemoryUsage");
                return 0;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return -1;
            }
        }

        public bool UpdateLogPath(string _logPath)
        {
            try
            {
                var search = from _conf in dataContext.Configuration
                             select _conf;

                if (search.Count() > 0)
                {
                    search.First().logPath = _logPath;
                }

                dataContext.SubmitChanges();

                writeLog("UpdateLogPath");
                return true;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public string GetLogPath()
        {
            try
            {
                var search = (from conf in dataContext.Configuration
                             select conf).First().logPath;

                if (search.Count() > 0)
                    return search;

                writeLog("GetLogPath");
                return "";
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return null;
            }
        }

        public bool UpdateMaxHddUsage(int _maxHddUsage)
        {
            try
            {
                var search = from _conf in dataContext.Configuration
                             select _conf;

                if (search.Count() > 0)
                {
                    search.First().maxHddUsage = _maxHddUsage;
                }

                dataContext.SubmitChanges();

                writeLog("UpdateMaxHddUsage");
                return true;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public int GetMaxHddUsage()
        {

            try
            {

                var search = (from conf in dataContext.Configuration
                              select conf).First().maxHddUsage;

                if (search > 0)
                    return search;

                writeLog("GetMaxHddUsage");
                return 0;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return -1;
            }
        }

        public bool UpdateMaxTimeOut(int _maxTimeOut)
        {
            try
            {
                var search = from _conf in dataContext.Configuration
                             select _conf;

                if (search.Count() > 0)
                {
                    search.First().maxTimeOut = _maxTimeOut;
                }

                dataContext.SubmitChanges();

                writeLog("UpdateMaxTimeOut");
                return true;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public int GetMaxTimeOut()
        {
            try
            {
                var search = (from conf in dataContext.Configuration
                             select conf).First().maxTimeOut;

                if (search > 0)
                    return search;

                writeLog("GetMaxTimeOut");
                return 0;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return -1;
            }
        }

        public string GetServerSMTP()
        {
            try
            {
                var search = (from conf in dataContext.Configuration
                             select conf).First().serverSMTP;

                if (search != null)
                    return search;

                writeLog("GetServerSMTP");
                return "";
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return "";
            }
        }

        public string GetUserSMTP()
        {
            try
            {
                var search = (from conf in dataContext.Configuration
                              select conf).First().userSMTP;

                if (search != null)
                    return search;

                writeLog("GetUserSMTP");
                return "";
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return "";
            }
        }

        public string GetPwdSMTP()
        {
            try
            {
                var search = (from conf in dataContext.Configuration
                              select conf).First().pwdSMTP;

                if (search != null)
                    return search;

                writeLog("GetPwdSMTP");
                return "";
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return "";
            }
        }

        public bool SendEmail(string _to, string _subject, string _body)
        {
            try
            {
                MailMessage email = new MailMessage();

                email.From = new System.Net.Mail.MailAddress(GetUserSMTP());
                email.To.Add(new System.Net.Mail.MailAddress(_to));
                email.IsBodyHtml = true;
                email.Subject = _subject;
                email.Body = _body;

                SmtpClient server = new SmtpClient();
                server.Host = GetServerSMTP();
                server.Credentials = new System.Net.NetworkCredential(GetUserSMTP(), GetPwdSMTP());
                server.Port = 587;
                server.EnableSsl = true;

                server.Send(email);

                writeLog("SendEmail - " + _to + " - " + _subject);
                return true;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public bool SendTweet(string _tweetMessage)
        {
            try
            {
                TwitterClientInfo twitterClientInfo = new TwitterClientInfo();

                twitterClientInfo.ConsumerKey = Framework.Properties.Settings.Default.ConsumerKey;
                twitterClientInfo.ConsumerSecret = Framework.Properties.Settings.Default.ConsumerSecret;
                string AccessToken = Framework.Properties.Settings.Default.AccessToken;
                string AccessTokenSecret =Framework.Properties.Settings.Default.AccessTokenSecret;

                TwitterService twitterService = new TwitterService(twitterClientInfo);

                twitterService.AuthenticateWith(AccessToken, AccessTokenSecret);

                TwitterStatus twitterStatus = twitterService.SendTweet(_tweetMessage);

                writeLog("SendTweet - " + _tweetMessage);
                return true;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public bool SendSMS(string _tlf, string _txt)
        {
            try
            {

                string user = Framework.Properties.Settings.Default.UserSMS;
                string password = Framework.Properties.Settings.Default.PasswordSMS;
                string sender = "ServMonUOC";

                string url = "https://apimovilidad.jmeservicios.com/sms_send"+
                             "?account=" + user + "&password=" + password +
                             "&to=%2B34" + _tlf.Trim() + "&text=" + _txt +
                             "&from=" + sender +
                             "&callback=http://10.10.20.39/fsafd?test=Xxxx HTTP 1.0";
                
                WebRequest request = WebRequest.Create(url);
                request.Method = "POST";
                request.ContentType = "application/x-www-form-urlencoded";

                WebResponse response = request.GetResponse();
                writeLog("SendSMS - " + _tlf + " - " + _txt);
                writeLog(((HttpWebResponse)response).StatusDescription);
                response.Close();

                return true;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public bool NewPassword(string _username)
        {
            try
            {
                IUserDAL _user = new UserDALImpl();
                User user = new User();

                string _newPassword = "01234567";
                Random rnd = new Random();

                for (int i = 0; i < 8; i++)
                {
                    _newPassword = _newPassword.Replace(_newPassword[i], Convert.ToChar(rnd.Next(64, 122)));
                }
                
                if (!_user.ChangePassword(_username, _newPassword))
                    return false;
                
                user = _user.GetUser(_username);
                
                string subject = "Canvi de contrasenya d'accés a Server Monitor"; 
                string body = "<html><body>";

                body += "La nova contrasenya de l'usuari <b>" + _username + "</b> és: <b>" + _newPassword + "</b>";
                body += "<br>ServerMonitor</body></html>";

                SendEmail(user.Email, subject, body);
                writeLog("NewPassword - " + user.Email);
                return true;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public bool UpdateConfiguration(Configuration _conf)
        {
            try
            {
                var search = from c in dataContext.Configuration
                             select c;

                if (search.Count() > 0)
                {

                    if ( _conf.DomainAdminUser.Length > 0)
                        search.First().domainAdminUser = _conf.DomainAdminUser.Trim();
                    if (_conf.DomainPwdUser.Length > 0)
                        search.First().domainPwdUser = _conf.DomainPwdUser;
                    if (_conf.Domain.Length > 0)
                        search.First().domain = _conf.Domain;
                    if (_conf.ServerSMTP.Length > 0)
                        search.First().serverSMTP = _conf.ServerSMTP.Trim();
                    if (_conf.UserSMTP.Length > 0 )
                        search.First().userSMTP = _conf.UserSMTP.Trim();
                    if (_conf.PwdSMTP.Length > 0)
                        search.First().pwdSMTP = _conf.PwdSMTP.Trim();

                    dataContext.SubmitChanges();

                    writeLog("UpdateConfiguration");
                    return true;
                }

                return false;
            }
            catch (Exception e)
            {
                writeLog(e.Message);
                return false;
            }
        }

        public void writeLog(string _line)
        {
            string path = GetLogPath();
            try
            {
                if (!Directory.Exists(path))
                {
                    Directory.CreateDirectory(path);
                }

                TextWriter tw = new StreamWriter(path + "\\log_ServerMonitor_" +
                                                  DateTime.Now.Year + DateTime.Now.Month + DateTime.Now.Day + ".txt", true);
                tw.WriteLine(DateTime.Now + " - " + _line);
                tw.Close();
            }
            catch
            {}
        }

        public bool existDB()
        {
            try
            {
                if (dataContext.DatabaseExists())
                    return true;
                else
                {
                    writeLog("Error de connexió amb la base de dades");
                    return false;
                }
            }
            catch
            {
                writeLog("Error de connexió amb la base de dades");
                return false;
            }
        }
    }
}
