﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Framework
{
    public interface IConfigurationDAL
    {
        Configuration GetConfiguration();

        bool UpdateTimeUpdate(int _interval);
        int GetTimeUpdate();

        bool UpdateMaxTimeCPU(int _maxTimeCPU);
        int GetMaxTimeCPU();
            
        bool UpdateMaxMemoryUsage(int _maxMemoryUsage);        
        int GetMaxMemoryUsage();
        
        bool UpdateMaxHddUsage(int _maxHddUsage);                
        int GetMaxHddUsage();

        bool UpdateLogPath(string _logPath);
        string GetLogPath();
        void writeLog(string _line);
                            
        bool UpdateMaxTimeOut(int _maxTimeOut);                    
        int GetMaxTimeOut();

        string GetServerSMTP();
        string GetUserSMTP();
        string GetPwdSMTP();

        bool SendEmail(string _to, string _subject, string _body);
        bool SendTweet(string _tweetMessage);
        bool SendSMS(string _tlf, string _txt);

        bool NewPassword(string _username);

        bool UpdateConfiguration(Configuration _conf);
        bool existDB();
    }
}
