﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Framework
{
    public interface IUserDAL
    {
        User GetUser(int _userId);

        User GetUser(string _username);

        bool VerifyUser(string _username, string _password);

        bool ChangePassword(string _username, string _password);

        List<User> GetAllUsers();

        bool AddUserGroup(string _group);
        
        bool UpdateUserGroup(UserGroup _group);

        bool DisableUser(string _username);

        bool EnabledUser(string _username);

        bool AddUser(User _user);

        bool EditUser(User _user);

        #region usergroup
        
        List<UserGroup> GetAllUserGroups();

        UserGroup GetUserGroup(int _groupId);
    
        #endregion


        #region Permissions

        List<User> GetUsersPermissionToServerService(int _serverServiceId);

        bool UpdatePermissions(int _userId, List<int> _unassigned, List<int> _assigned);

        #endregion
    }
}
