﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Framework
{
    public class ServerServiceDALImpl : IServerServiceDAL
    {
        Framework.Linq.LinqToSqlDataContext dataContext = new Framework.Linq.LinqToSqlDataContext();
        IConfigurationDAL conf = new ConfigurationDALImpl();

        public int GetServerServiceId(int _serverId, int _serviceId)
        {
            try
            {
                var searchServerServiceId = from s in dataContext.ServerServices
                                            where s.service_id == _serviceId
                                               && s.server_id == _serverId
                                            select s;

                if (searchServerServiceId.Count() > 0)
                {
                    return searchServerServiceId.First().serverService_id;
                }
                else
                {
                    return 0;
                }
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return -1;
            }
        }

        public int GetServiceOfServerAndServerServiceId(int _serverId, int _serverServiceId)
        {
            try
            {
                var searchServiceId = from s in dataContext.ServerServices
                                      where s.serverService_id == _serverServiceId
                                         && s.server_id == _serverId
                                      select s;

                if (searchServiceId.Count() > 0)
                {
                    return searchServiceId.First().service_id;
                }
                else
                {
                    return 0;
                }
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return -1;
            }
        }

        public int GetServiceByServerServiceId(int _serverServiceId)
        {
            try
            {
                var searchServiceId = from s in dataContext.ServerServices
                                      where s.serverService_id == _serverServiceId
                                      select s;

                if (searchServiceId.Count() > 0)
                
                    return searchServiceId.First().service_id;
                
                else
                
                    return 0;
                
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return -1;
            }

        }

        public int GetServerByServerServiceId(int _serverServiceId)
        {
            try
            {
                var searchServiceId = from s in dataContext.ServerServices
                                      where s.serverService_id == _serverServiceId
                                      select s;

                if (searchServiceId.Count() > 0)
                
                    return searchServiceId.First().server_id;
                
                else
                
                    return 0;
                
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return -1;
            }
        }

        public int MaxServerServiceId()
        {
            try
            {
                var search = (from s in dataContext.ServerServices
                              select s.serverService_id).Max();

                if (search > 0)
                {
                    return search;
                }
                else
                {
                    return 0;
                }
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return -1;
            }
        }

        public bool AddServerService(int _serverId, int _serviceId)
        {
            try
            {

                int max = (from s in dataContext.ServerServices
                           select s.serverService_id).Max();

                Linq.ServerServices serverService = new Linq.ServerServices();

                serverService.serverService_id = max + 1;
                serverService.server_id = _serverId;
                serverService.service_id = _serviceId;
                serverService.status = 0;

                dataContext.ServerServices.InsertOnSubmit(serverService);
                dataContext.SubmitChanges();

                return true;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return false;
            }
        }

        public bool ActiveServerService(int _serverId, int _serviceId)
        {

            try
            {

                var search = from ss in dataContext.ServerServices
                             where ss.server_id == _serverId
                                 & ss.service_id == _serviceId
                             select ss;

                Linq.ServerServices _ss = new Linq.ServerServices();

                if (search.Count() > 0)
                {
                    _ss = search.First();
                    _ss.status = 1;
                    dataContext.SubmitChanges();

                    Linq.Permissions permission = new Linq.Permissions();

                    permission.serverService_id = _ss.serverService_id;
                    permission.user_id = 0;

                    dataContext.Permissions.InsertOnSubmit(permission);
                    dataContext.SubmitChanges();

                }
                return true;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return false;
            }
        }

        public bool InactiveServerService(int _serverId, int _serviceId)
        {

            try
            {

                var search = from ss in dataContext.ServerServices
                             where ss.server_id == _serverId
                                 & ss.service_id == _serviceId
                             select ss;

                Linq.ServerServices _ss = new Linq.ServerServices();

                if (search.Count() > 0)
                {
                    _ss = search.First();
                    _ss.status = 0;
                    dataContext.SubmitChanges();

                    //Delete permissions for this serverService

                    var searchPermissions = from sp in dataContext.Permissions
                                            where sp.serverService_id == _ss.serverService_id
                                            select sp;

                    if (searchPermissions.Count() > 0)
                    {
                        dataContext.Permissions.DeleteOnSubmit(searchPermissions.First());
                        dataContext.SubmitChanges();
                    }
                   
                }
                return true;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return false;
            }
        }

        public List<ServerService>  GetServerServicesByServer(int _serverId)
        {
            List<ServerService> ss = new List<ServerService>();

            try
            {
                var search = from s in dataContext.ServerServices
                                where s.server_id == _serverId
                                   & s.status == 1
                            select s;

                foreach(var _ss in search)
                {
                    ss.Add(new ServerService(_ss.serverService_id, _ss.server_id, _ss.service_id, _ss.status));
                }

                return ss;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return null;
            }
        }

    }
}
