﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Framework
{
    public class ServiceDALImpl : IServiceDAL
    {
        Framework.Linq.LinqToSqlDataContext dataContext = new Framework.Linq.LinqToSqlDataContext();
        IConfigurationDAL conf = new ConfigurationDALImpl();

        public Service GetService(int _serviceId)
        {
            try
            {
                Service _service = new Service();

                var searchServiceById = from s in dataContext.Service
                                        where s.service_id == _serviceId
                                        select s;

                if (searchServiceById.Count() > 0)
                {
                    _service.Id = searchServiceById.First().service_id;
                    _service.Name = searchServiceById.First().name.Trim();
                    _service.Description = searchServiceById.First().description.Trim();
                    _service.Ressolution = searchServiceById.First().resolution.Trim();
                }
                else
                {
                    _service.Name = "No existeix";
                }
                return _service;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return null;
            }
        }

        public List<Service> GetAllServices()
        {
            try
            {
                List<Service> _services = new List<Service>();

                foreach (Linq.Service _service in dataContext.Service)
                {
                    Service _serviceTmp = GetService(_service.service_id);
                    _services.Add(_serviceTmp);
                }

                return _services;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return null;
            }
        }

        public List<Service> GetServicesByServer(int _serverId)
        {
            try
            {
                List<Service> _services = new List<Service>();

                var searchServicesByServerId =
                                       from s in dataContext.ServerServices
                                       where s.server_id == _serverId
                                           & s.status == 1
                                       select s.service_id;


                foreach (int ss in searchServicesByServerId)
                {
                    _services.Add(GetService(ss));
                }

                return _services;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return null;
            }
        }

        public bool UpdateService(Service _service)
        {
            try
            {
                var search = from serv in dataContext.Service
                             where serv.service_id == _service.Id
                             select serv;

                Linq.Service service = search.First();

                service.service_id = _service.Id;
                service.name = _service.Name;
                service.description = _service.Description;
                service.resolution = _service.Ressolution;

                dataContext.SubmitChanges();

                return true;
            }
            catch (Exception e)
            {
                conf.writeLog(e.Message);
                return false;
            }
        }
    }
}
