﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using ServerMonitorWP7.ServerInfo;

namespace ServerMonitorWP7.Alerts
{
    public partial class Alerts : PhoneApplicationPage
    {
         
        ServerInfoClient ws_ServerInfo = new ServerInfoClient();

        public Alerts()
        {
            InitializeComponent();

            //Event handler and call to webservice to get all uread alarms for this user
            ws_ServerInfo.GetAlarmsUnreadByUserIdCompleted
                        += new EventHandler<GetAlarmsUnreadByUserIdCompletedEventArgs>(GetAlarms);
    
            ws_ServerInfo.GetAlarmsUnreadByUserIdAsync(Convert.ToInt32(MainPage.userId.ToString()));
        }

        void GetAlarms(object sender, GetAlarmsUnreadByUserIdCompletedEventArgs e)
        {
            //Get all alarms unread for this user
            List<ServerInfo.vAlerts> alertList = e.Result;
            
            if (alertList.Count > 0)
            {

                foreach (ServerInfo.vAlerts alert in alertList)
                {
                    StackPanel stk = new StackPanel();

                    stk.Name = alert.Id.ToString();
                    stk.Width = 430;
                    stk.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;

                    HyperlinkButton server = new HyperlinkButton();
                    server.Name = "server_" + alert.Id.ToString();
                    server.NavigateUri = new Uri("/Alerts/AlertDetail.xaml?id=" +alert.Id.ToString(), UriKind.Relative);
                    server.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                    server.Foreground = new SolidColorBrush(Colors.Orange);        
                    server.Content = alert.Server.Trim();
                    server.FontSize = 25;

                    HyperlinkButton service = new HyperlinkButton();

                    service.Name = "service_" + alert.Id.ToString();
                    service.Content = alert.Service.Trim();
                    server.NavigateUri = new Uri("/Alerts/AlertDetail.xaml?id=" + alert.Id.ToString(), UriKind.Relative);
                    service.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                    service.Padding = new Thickness(30,3,0,0);
                    service.FontSize = 20;

                    TextBlock instant = new TextBlock();
                    
                    instant.Name = "instant_" + alert.Id.ToString();
                    instant.Text = alert.Instant.ToString();
                    instant.HorizontalAlignment = System.Windows.HorizontalAlignment.Right;
                    instant.FontSize = 18;

                    stk.Children.Add(server);
                    stk.Children.Add(service);
                    stk.Children.Add(instant);
  
                    AlertList.Items.Add(stk);

                }
            }
            else
            {
                MessageBox.Show("No hi han alertes per llegir");
            }
        }

        //Button logoff for this app
        private void bSortir_Click(object sender, RoutedEventArgs e)
        {
            MainPage.userId = 0;
            ws_ServerInfo.InsertAccessLogAsync(MainPage.userId, "Ha sortit de la aplicació WP7");
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        //If the user return to this page with BackButton com back to Main Page if this is not loggedIn
        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (MainPage.userId.Equals(0))
            {
                NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
            }
        }

        //Button to go serverList
        private void bServers_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Servers/Servers.xaml", UriKind.Relative));
        }
    }
}