﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using ServerMonitorWP7.ServerInfo;

namespace ServerMonitorWP7
{
    public partial class MainPage : PhoneApplicationPage
    {

        ServerInfoClient ws_ServerInfo = new ServerInfoClient();

        public static int userId;
        private static bool _eventGenerated;
        private static bool _eventPwd;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            //This var. are for control to create only one handler
            _eventGenerated = false;
            _eventPwd = false;

        }

        private void tbUsername_MouseEnter(object sender, MouseEventArgs e)
        {            
            //Erase textbox on enter first time
            if (tbUsername.Text.Equals("Usuari"))
            {
                tbUsername.Text = "";
            }
        }

        private void tbPassword_MouseEnter(object sender, MouseEventArgs e)
        {
            //Erase textbox on enter first time
            if (tbPassword.Password.Equals("Contrasenya"))
            {
                tbPassword.Password = "";
            }
        }

        private void bLogin_Click(object sender, RoutedEventArgs e)
        {

            //Verify minim values before send a call to webservice
            if (tbUsername.Text.Length < 3)
            {
                MessageBox.Show("Has d'introduir un usuari vàlid");
            }
            else if (tbPassword.Password.Length == 0)
            {
                MessageBox.Show("La contrasenya no pot estar en blanc");
            }
            else
            {
                //First time generated the event handler
                if (!_eventGenerated)
                {
                    ws_ServerInfo.VerifyUserCompleted += new EventHandler<VerifyUserCompletedEventArgs>(verifyCompleted);
                    _eventGenerated = true;                    
                }
                ws_ServerInfo.VerifyUserAsync(tbUsername.Text, tbPassword.Password);    
            }
        }

        void verifyCompleted(object sender, VerifyUserCompletedEventArgs e)
        {
            //verify result of webservice call
            if (e.Result.Equals(false))
            {
                MessageBox.Show("Usuari o contrasenya incorrecta", "Error", MessageBoxButton.OK);
                ws_ServerInfo.InsertAccessLogSystemAsync("Intent fallit accés WP7");
            }
            else
            {
                //If login is ok get all user information for use the id
                ws_ServerInfo.GetUserByUsernameCompleted += new EventHandler<GetUserByUsernameCompletedEventArgs>(GetUser);
                ws_ServerInfo.GetUserByUsernameAsync(tbUsername.Text);                        
            }
        }

        void GetUser(object sender, GetUserByUsernameCompletedEventArgs e)
        {
            //When get userId redirect to Alerts page
            ServerInfo.User user = e.Result;
            userId = user.UserId;
            ws_ServerInfo.InsertAccessLogAsync(userId, "Inici de sessió per WP7");
            NavigationService.Navigate(new Uri("/Alerts/Alerts.xaml", UriKind.Relative));
        }

        private void newPassword_Click(object sender, RoutedEventArgs e)
        {
            //If the username exist send email to user with a new password

            if (!_eventPwd)
            {
                ws_ServerInfo.NewPasswordCompleted +=
                    new EventHandler<NewPasswordCompletedEventArgs>(NewPasswordCompleted);
                _eventPwd = true;
            }
            ws_ServerInfo.NewPasswordAsync(tbUsername.Text.Trim());
            ws_ServerInfo.InsertAccessLogAsync(0, "S'envia nova contrasenya mitjançant WP7 a " + tbUsername.Text.Trim() + " si existeix");
        }

        void NewPasswordCompleted(object sender, NewPasswordCompletedEventArgs e)
        {
            if (e.Result)
                MessageBox.Show("S'ha enviat una nova contrasenya a la teva bústia de correu");

            else
                MessageBox.Show("Usuari desconegut. Escriu un usuari vàlid");
        }

    }
}