﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using ServerMonitorWP7.ServerInfo;

namespace ServerMonitorWP7.Servers
{
    public partial class ServerDetail : PhoneApplicationPage
    {
        ServerInfoClient ws_ServerInfo = new ServerInfoClient();
        private static int serverId;
        private static int userId;

        //Constructor
        public ServerDetail()
        {
            InitializeComponent();


            //Create the two textblock to contains all the services
            //associated to server

            TextBlock tbHardware = new TextBlock();

            tbHardware.FontWeight = FontWeights.Bold;
            tbHardware.Text = "Hardware                                  ";
            tbHardware.Width = 430;
            tbHardware.Height = 50;
            tbHardware.FontSize = 28;
            tbHardware.VerticalAlignment = VerticalAlignment.Center;
            tbHardware.TextDecorations = TextDecorations.Underline;
            tbHardware.Padding = new Thickness(5, 10, 0, 20);
     
            HardwareList.Items.Add(tbHardware);
            HardwareList.Padding = new Thickness(20, 3, 0, 20);

            TextBlock tbService = new TextBlock();

            tbService.FontWeight = FontWeights.Bold;
            tbService.Text = "Serveis                                    ";
            tbService.Width = 430;
            tbService.Height = 50;
            tbService.VerticalAlignment = VerticalAlignment.Center;
            tbService.FontSize = 28;
            tbService.TextDecorations = TextDecorations.Underline;
            tbService.Padding = new Thickness(5, 10, 0, 20);

            ServiceList.Items.Add(tbService);
            ServiceList.Padding = new Thickness(20, 3, 0, 20);

        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {

            //Get the parameters to pass by URI
            //Contains the serverId and the userName
            if (this.NavigationContext.QueryString.ContainsKey("id"))
            {
                string id = NavigationContext.QueryString["id"];
                serverId = Convert.ToInt32(id);

                string name = NavigationContext.QueryString["name"];
                TitleSection.Text = name;

                userId = Convert.ToInt32(MainPage.userId.ToString());
                
                //Call ppal function
                getServer();
            }
        }
            
        private void getServer()
        {

            //Create the EventHandler and call de webservice
            ws_ServerInfo.GetViewRealTimeServerCompleted
                    += new EventHandler<GetViewRealTimeServerCompletedEventArgs>(GetViewRealTimeServerCompleted);

            ws_ServerInfo.GetViewRealTimeServerAsync(serverId, userId);

        }
    
        private void GetViewRealTimeServerCompleted(object sender, GetViewRealTimeServerCompletedEventArgs e)
        {
            //Get status of realtime server
            List<vRealTimeServer> rt = new List<vRealTimeServer>();
            rt = e.Result;
            
            int statusCPU = 0;
            string serviceCPU = "";
            int statusHDD = 0, maxHDD = 0;
            string serviceHDD = "";

            if (!rt.Equals(null))
            {

                foreach (vRealTimeServer service in rt)
                {
                    Grid gr = new Grid();

                    gr.RowDefinitions.Add(new RowDefinition());
                    gr.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(220, GridUnitType.Pixel) });
                    gr.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(200, GridUnitType.Pixel) });

                    #region services

                    //The services under 100 are Software Services

                    if (service.ServiceId < 100)
                    {
                        TextBlock _service = new TextBlock();

                        _service.Text = service.ServiceName.Trim() + ": ";
                        _service.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                        _service.Padding = new Thickness(20, 10, 3, 0);
                        _service.FontSize = 22;

                        TextBlock _status = new TextBlock();

                        if (service.Status == 0)
                        {
                            _status.Text = "Aturat";
                            _status.Foreground = new SolidColorBrush(Colors.Red);
                        }
                        else
                        {
                            _status.Text = "Funcionant";
                            _status.Foreground = new SolidColorBrush(Color.FromArgb(255,123,209,70));
                        }
                        _status.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                        _status.FontSize = 22;

                        gr.Children.Add(_service);
                        Grid.SetRow(_service, 0);
                        Grid.SetColumn(_service, 0);

                        gr.Children.Add(_status);
                        Grid.SetRow(_status, 0);
                        Grid.SetColumn(_status, 1);

                        ServiceList.Items.Add(gr);
                    }
                    #endregion

                    #region hardware 
                    //Init hardware services
                    else
                    {
                        //Network
                        if (service.ServiceId == 101)
                        {
                            TextBlock _service = new TextBlock();

                            _service.Text = service.ServiceName.Trim() + ": ";
                            _service.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                            _service.Padding = new Thickness(20, 10, 3, 0);
                            _service.FontSize = 22;

                            TextBlock _status = new TextBlock();

                            if (service.Status == 0)
                            {
                                _status.Text = "Aturat";
                                _status.Foreground = new SolidColorBrush(Colors.Red);
                            }
                            else
                            {
                                _status.Text = "Funcionant";
                                _status.Foreground = new SolidColorBrush(Color.FromArgb(255, 123, 209, 70));
                            }
                            _status.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                            _status.FontSize = 22;

                            gr.Children.Add(_service);
                            Grid.SetRow(_service, 0);
                            Grid.SetColumn(_service, 0);

                            gr.Children.Add(_status);
                            Grid.SetRow(_status, 0);
                            Grid.SetColumn(_status, 1);

                            HardwareList.Items.Add(gr);
                        }

                        //Memory
                        if (service.ServiceId == 102)
                        {
                            TextBlock _service = new TextBlock();
                            
                            _service.Text = service.ServiceName.Trim() + ": ";
                            _service.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                            _service.Padding = new Thickness(20, 10, 3, 0);
                            _service.FontSize = 22;

                            TextBlock _status = new TextBlock();
                            _status.Text = 100 - service.Status + " % disponible";

                            if (service.Status > 90)
                            {
                                _status.Foreground = new SolidColorBrush(Colors.Red);
                            }
                            else
                            {
                                _status.Foreground = new SolidColorBrush(Color.FromArgb(255, 123, 209, 70));
                            }
                            _status.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                            _status.FontSize = 20;

                            gr.Children.Add(_service);
                            Grid.SetRow(_service, 0);
                            Grid.SetColumn(_service, 0);

                            gr.Children.Add(_status);
                            Grid.SetRow(_status, 0);
                            Grid.SetColumn(_status, 1);

                            HardwareList.Items.Add(gr);
                        }

                        //CPU
                        if (service.ServiceId > 102 && service.ServiceId < 107)
                        {
                            serviceCPU = "CPU";
                            if (statusCPU == 0)
                                statusCPU = service.Status;
                            else
                                statusCPU = (statusCPU + service.Status) / 2;
                        }
                        if (service.ServiceId > 106 && service.ServiceId < 111)
                        {
                            serviceHDD = "HDD";
                            maxHDD = service.MaxValue;
                            if (statusHDD == 0)
                                statusHDD = service.Status;
                            else
                                statusHDD = (statusHDD + service.Status) / 2;
                        }
                    }
                    #endregion
                }

                // The elements CPU and HDD are customs for many elements.
                #region hardwarePlus

                // CPU
                if (statusCPU > 0)
                {
                    Grid grid = new Grid();

                    grid.RowDefinitions.Add(new RowDefinition());
                    grid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(220, GridUnitType.Pixel) });
                    grid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(200, GridUnitType.Pixel) });

                    TextBlock _serviceCPU = new TextBlock();

                    _serviceCPU.Text = serviceCPU.Trim() + ": ";
                    _serviceCPU.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                    _serviceCPU.Padding = new Thickness(20, 10, 3, 0);
                    _serviceCPU.FontSize = 22;

                    TextBlock _statusCPU = new TextBlock();
                    _statusCPU.Text = statusCPU + " % en ús";

                    if (statusCPU > 90)
                    {
                        _statusCPU.Foreground = new SolidColorBrush(Colors.Red);
                    }
                    else
                    {
                        _statusCPU.Foreground = new SolidColorBrush(Color.FromArgb(255, 123, 209, 70));
                    }
                    _statusCPU.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                    _statusCPU.FontSize = 20;

                    grid.Children.Add(_serviceCPU);
                    Grid.SetRow(_serviceCPU, 0);
                    Grid.SetColumn(_serviceCPU, 0);

                    grid.Children.Add(_statusCPU);
                    Grid.SetRow(_statusCPU, 0);
                    Grid.SetColumn(_statusCPU, 1);

                    HardwareList.Items.Add(grid);
                }

                //  HDD
                if (statusHDD > 0)
                {
                    Grid grid2 = new Grid();

                    grid2.RowDefinitions.Add(new RowDefinition());
                    grid2.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(220, GridUnitType.Pixel) });
                    grid2.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(200, GridUnitType.Pixel) });

                    TextBlock _serviceHDD = new TextBlock();

                    _serviceHDD.Text = serviceHDD.Trim() + ": ";
                    _serviceHDD.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                    _serviceHDD.Padding = new Thickness(20, 10, 3, 0);
                    _serviceHDD.FontSize = 22;

                    TextBlock _statusHDD = new TextBlock();
                    _statusHDD.Text = 100 - statusHDD + " % lliure";

                    if (statusHDD > maxHDD)
                    {
                        _statusHDD.Foreground = new SolidColorBrush(Colors.Red);
                    }
                    else
                    {
                        _statusHDD.Foreground = new SolidColorBrush(Color.FromArgb(255, 123, 209, 70));
                    }
                    _statusHDD.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                    _statusHDD.FontSize = 20;

                    grid2.Children.Add(_serviceHDD);
                    Grid.SetRow(_serviceHDD, 0);
                    Grid.SetColumn(_serviceHDD, 0);

                    grid2.Children.Add(_statusHDD);
                    Grid.SetRow(_statusHDD, 0);
                    Grid.SetColumn(_statusHDD, 1);

                    HardwareList.Items.Add(grid2);
                }
                #endregion

            }
            else
            {
                MessageBox.Show("Error al carregar la informació");
                NavigationService.Navigate(new Uri("/Servers/Servers.xaml", UriKind.Relative));
            }

        }

        //Event of button redirect to Alerts 
        private void bAlerts_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Alerts/Alerts.xaml", UriKind.Relative));
        }

        //Event of button to redirect to Servers
        private void bServers_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Servers/Servers.xaml", UriKind.Relative));
        }

        //EventButton not exit application, this button logOff
        private void bSortir_Click(object sender, RoutedEventArgs e)
        {
            MainPage.userId = 0;
            ws_ServerInfo.InsertAccessLogAsync(MainPage.userId, "Ha sortit de la aplicació WP7");
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        //If the user return to this page with BackButton com back to Main Page if this is not loggedIn
        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (MainPage.userId.Equals(0))
            {
                NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
            }
        }
    }
}