﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using ServerMonitorWP7.ServerInfo;
using System.Windows.Media.Imaging;

namespace ServerMonitorWP7.Servers
{
    public partial class Servers : PhoneApplicationPage
    {

        ServerInfoClient ws_ServerInfo = new ServerInfoClient();

        public Servers()
        {
            InitializeComponent();

            //Create the handler and call the WebService

            ws_ServerInfo.GetServersByUserIdCompleted +=
                    new EventHandler<GetServersByUserIdCompletedEventArgs>(GetServersByUserIdCompleted);

            //Get servers where the userId have permissions
            ws_ServerInfo.GetServersByUserIdAsync(MainPage.userId);

        }


        void GetServersByUserIdCompleted(object sender, GetServersByUserIdCompletedEventArgs e)
        {
            //Get server list
            List<vServers> serverList = e.Result;

            if (serverList.Count >  0)
            {

                foreach (ServerInfo.vServers server in serverList)
                {
                    Grid grid = new Grid();

                    grid.ColumnDefinitions.Add(new ColumnDefinition()
                    {
                        Width = new GridLength(1, GridUnitType.Auto)
                    });

                    grid.ColumnDefinitions.Add(new ColumnDefinition()
                    {
                        Width = new GridLength(1, GridUnitType.Auto)
                    });

                    grid.RowDefinitions.Add(new RowDefinition()
                    {
                        Height = new GridLength(1, GridUnitType.Auto)
                    });

                    Image _status = new Image();
                    _status.Width = 50;
                    _status.Height = 50;
                  
                    //Show the status of server with image
                    if (server.Status == 1)
                    {
                        _status.Source = new BitmapImage(new Uri("/ServerMonitorWP7;component/img/server-ok.png", UriKind.RelativeOrAbsolute));
                    }
                    else
                    {
                        _status.Source = new BitmapImage(new Uri("/ServerMonitorWP7;component/img/server-ko.png", UriKind.RelativeOrAbsolute));
                        
                    }

                    HyperlinkButton serverStatus = new HyperlinkButton();
                    serverStatus.BorderBrush = new SolidColorBrush(Colors.Black);
                    serverStatus.Name = server.Id.ToString();
                    serverStatus.NavigateUri = new Uri("/Servers/ServerDetail.xaml?id=" + server.Id.ToString() + "&name=" + server.Name, UriKind.Relative);
                    serverStatus.Width = 50;
                    serverStatus.Height = 50;

                    StackPanel stk = new StackPanel();

                    HyperlinkButton _server = new HyperlinkButton();
                    _server.Name = "server_" + server.Id.ToString();
                    _server.NavigateUri = new Uri("/Servers/ServerDetail.xaml?id=" + server.Id.ToString() + "&name=" + server.Name, UriKind.Relative);
                    _server.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                    _server.Foreground = new SolidColorBrush(Colors.Orange);
                    _server.Content = server.Name.Trim();
                    _server.FontSize = 30;

                    TextBlock alerts = new TextBlock();

                    alerts.Name = "alerts_" + server.Id.ToString();
                    alerts.Text = "Alarmes en curs: " + server.CurrentAlarms.ToString();
                    alerts.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                    alerts.Padding = new Thickness(50, 3, 0, 0);
                    alerts.FontSize = 20;

                    stk.Children.Add(_server);
                    stk.Children.Add(alerts);

                    grid.Children.Add(_status);
                    Grid.SetRow(_status, 0);
                    Grid.SetColumn(_status, 0);

                    grid.Children.Add(serverStatus);
                    Grid.SetRow(serverStatus, 0);
                    Grid.SetColumn(serverStatus, 0);

                    grid.Children.Add(stk);
                    Grid.SetRow(stk, 0);
                    Grid.SetColumn(stk, 1);

                    grid.Margin = new Thickness(0, 10, 0, 0);

                    ServerList.Items.Add(grid);
                }
            }
            else
            {
                MessageBox.Show("No hi han servidors per visualitzar");
            }

        }

        //Button redirect to Alerts
        private void bAlerts_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Alerts/Alerts.xaml", UriKind.Relative));
        }

        //Button Redirect himself
        private void bServers_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Servers/Servers.xaml", UriKind.Relative));
        }

        //Button logoff application
        private void bSortir_Click(object sender, RoutedEventArgs e)
        {
            MainPage.userId = 0;
            ws_ServerInfo.InsertAccessLogAsync(MainPage.userId, "Ha sortit de la aplicació WP7");
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        //If the user return to this page with BackButton com back to Main Page if this is not loggedIn
        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (MainPage.userId.Equals(0))
            {
                NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
            }
        }

    }
}