﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using ServerMonitorWPF;
using System.Data;
using System.Windows.Threading;
using System.IO;
using System.Diagnostics;
using System.ServiceProcess;
using System.Data.SqlClient;
using Microsoft.SqlServer;

namespace ServerMonitorWPF
{

    public partial class MainWindow : Window
    {
        ServerInfo.ServerInfoClient wsServerInfo = new ServerInfo.ServerInfoClient();

        #region functions

        public MainWindow()
        {

            if (!wsServerInfo.existDB())
            {
                MessageBox.Show("No existeix la Base de dades");
                Close();
            }
            else
            {
                InitializeComponent();

                wsServerInfo.InsertAccessLogSystem("Inici de sessió a aplicació WPF");

                //Generate DropDownList with values of interval time
                cbTimeUpdate.Items.Add(1);
                cbTimeUpdate.Items.Add(3);
                cbTimeUpdate.Items.Add(5);
                cbTimeUpdate.Items.Add(10);
                cbTimeUpdate.Items.Add(30);
                cbTimeUpdate.Items.Add(60);
                cbTimeUpdate.SelectedItem = cbTimeUpdate.Items.GetItemAt(4);

                SetPathLog();
                DisableAll();
            }
        }

        private bool VerifyDBExist()
        {
            try
            {


                return true;
            }
            catch(Exception e)
            {
                wsServerInfo.writeLog(e.ToString());
                return false;
            }
        }

        //private bool VerifyDBExist()
        //{
        //    try
        //    {
        //        //try to connect to catalog with windows authentication
        //    string connectionString = "Data Source=LOCALHOST\\SQLEXPRESS; Integrated Security=SSPI;";

        //        SqlConnection conn = new SqlConnection(connectionString);
               
        //        conn.Open();

        //        if (conn.State == ConnectionState.Open)
        //        {
        //          //  MessageBox.Show("El SGDB existeix");

        //            string sql = "select * from sys.databases where name = 'ServerMonitor'";

        //            SqlCommand command = new SqlCommand(sql, conn);

        //            if (!command.ExecuteReader().Read())
        //            {
        //                MessageBox.Show("No existeix la BDD, procedim a generar-la");
        //                return false;
                        
        //                SqlConnection connection = new SqlConnection(connectionString);
        //                connection.Open();

        //                //read script sql to generate DBB and initial values

        //                //the catalog exist but no the database. Execute script to generate this

        //                SqlCommand commandCreateDB = new SqlCommand();
        //               // commandCreateDB.CommandType = CommandType.Text;
        //                commandCreateDB.Connection = connection;

        //                StreamReader sr = File.OpenText(@"C:\Servermonitor.sql");
        //                string line = sr.ReadLine();
        //                string sentence = "";

        //                while (line != null)
        //                {
        //                    sentence += line;
        //                    line = sr.ReadLine();

        //                    if (line.StartsWith("GO"))
        //                    {
        //                        commandCreateDB.CommandText = sentence;
        //                        commandCreateDB.ExecuteNonQuery();
        //                        sentence = "";
        //                        line = sr.ReadLine();
        //                    }
        //                }

        //                sr.Close();

        //                sr = File.OpenText(@"C:\ServermonitorFNC.sql");
        //                line = sr.ReadLine();
        //                sentence = "";


        //                while (line != null)
        //                {
        //                    sentence += line;
        //                    line = sr.ReadLine();

        //                    if (line.StartsWith("GO"))
        //                    {
        //                        commandCreateDB.CommandText = sentence;
        //                        commandCreateDB.ExecuteNonQuery();
        //                        sentence = "";
        //                        line = sr.ReadLine();
        //                    }
        //                }

        //                sr.Close();
                         
        //            }
        //            else
        //            {
        //               // MessageBox.Show("La BDD ja existeix");
        //                return true;
        //            }
                        
        //        }
               
        //        return true;
        //    }
        //    catch (SqlException ex)
        //    {
        //        MessageBox.Show(ex.Message);
        //        return false;
        //    }
        //}

        private void SetPathLog()
        {
            //Definy location to save the logs into solution directoy
            string pathLog = Directory.GetCurrentDirectory();
            pathLog = pathLog.Substring(0, pathLog.Length - 27);

            if (Directory.Exists(pathLog))
            {
                pathLog += "\\Logs";

                if (!Directory.Exists(pathLog))
                {
                    Directory.CreateDirectory(pathLog);
                    wsServerInfo.InsertAccessLogSystem("S'ha creat el directory pels logs");
                }

                wsServerInfo.UpdateLogPath(pathLog);
            }
            else
            {
                pathLog = @"C:\Logs";

                if (!Directory.Exists(pathLog))
                {
                    Directory.CreateDirectory(pathLog);
                    wsServerInfo.InsertAccessLogSystem("S'ha creat el directory pels logs");
                }

                wsServerInfo.UpdateLogPath(pathLog);
            }
        }

        private List<ServerInfo.Server> getAllServers()
        {
            
            try
            {
                List<ServerInfo.Server> _servers = wsServerInfo.GetAllActiveServers();
                List<ServerInfo.Server> localServers = new List<ServerInfo.Server>(); 

                 foreach (var server in _servers)
                 {

                     ServerInfo.Server _localServer = new ServerInfo.Server();

                     _localServer.Id = server.Id;
                     _localServer.Name = server.Name;
                     _localServer.Zone = wsServerInfo.GetServerZone(server.ZoneId).Name;

                     if (server.Critic)
                     {
                         _localServer.Critical = "Critic";
                     }
                     else
                     {
                         _localServer.Critical = "Normal";
                     }

                     localServers.Add(_localServer);
                 }

                return localServers;
            }
            catch
            {
                MessageBox.Show("Error amb la connexió amb la base de dades", "Error",
                                    MessageBoxButton.OK, MessageBoxImage.Error);
                wsServerInfo.InsertAccessLogSystem("Error amb la connexió amb la base de dades des de WPF");
                wsServerInfo.writeLog("Error amb la connexió amb la base de dades");
                return null;
            }
        }

        private void InitializeServices()
        {

            List<ServerInfo.Service> _services = wsServerInfo.GetAllServices();

            lbService1.Content = _services[0].Name;
            lbService2.Content = _services[1].Name;
            lbService3.Content = _services[2].Name;
            lbService4.Content = _services[3].Name;
            lbService5.Content = _services[4].Name;
            lbService6.Content = _services[5].Name;
            lbService7.Content = _services[6].Name;
            lbService8.Content = _services[7].Name;
            lbService9.Content = _services[8].Name;
            lbService10.Content = _services[9].Name;
            lbService11.Content = _services[10].Name;
            lbService12.Content = _services[11].Name;
            lbService13.Content = _services[12].Name;
            lbService14.Content = _services[13].Name;


        }

        private void UpdateInfoServer(ServerInfo.Server _server)
        {
            lbServerName.Content = _server.Name;
            lbDNS.Content = _server.DnsName;
            lbIP.Content = _server.Ip;
            lbMemoryServer.Content = _server.Memory + " Gb";
            lbCPU.Content = _server.CPU;
            lbHDD.Content = _server.HDD;
            lbDescription.Content = _server.Description;

            DisableHardwareAndServices();
            EnabledHardware(_server);
            EnabledServices(_server);
        }

        private void DisableHardwareAndServices()
        {
            //Disable Hardware except Network is always Enabled

            lbMemory.IsEnabled = false;
            slideMemory.IsEnabled = false;
            slideMemory.Value = 0;

            lbCPU1.IsEnabled = false;
            slideCPU1.IsEnabled = false;
            slideCPU1.Value = 0;

            lbHDD1.IsEnabled = false;
            slideHDD1.IsEnabled = false;
            slideHDD1.Value = 0;

            lbCPU2.IsEnabled = false;
            slideCPU2.IsEnabled = false;
            slideCPU2.Value = 0;

            lbHDD2.IsEnabled = false;
            slideHDD2.IsEnabled = false;
            slideHDD2.Value = 0;

            lbCPU3.IsEnabled = false;
            slideCPU3.IsEnabled = false;
            slideCPU3.Value = 0;

            lbHDD3.IsEnabled = false;
            slideHDD3.IsEnabled = false;
            slideHDD3.Value = 0;

            lbCPU4.IsEnabled = false;
            slideCPU4.IsEnabled = false;
            slideCPU4.Value = 0;

            lbHDD4.IsEnabled = false;
            slideHDD4.IsEnabled = false;
            slideHDD4.Value = 0;

            //Disable all services
            lbService1.IsEnabled = false;
            bService1.IsEnabled = false;
            bService1.Content = "";

            lbService2.IsEnabled = false;
            bService2.IsEnabled = false;
            bService2.Content = "";

            lbService3.IsEnabled = false;
            bService3.IsEnabled = false;
            bService3.Content = "";

            lbService4.IsEnabled = false;
            bService4.IsEnabled = false;
            bService4.Content = "";

            lbService5.IsEnabled = false;
            bService5.IsEnabled = false;
            bService5.Content = "";

            lbService6.IsEnabled = false;
            bService6.IsEnabled = false;
            bService6.Content = "";

            lbService7.IsEnabled = false;
            bService7.IsEnabled = false;
            bService7.Content = "";

            lbService8.IsEnabled = false;
            bService8.IsEnabled = false;
            bService8.Content = "";

            lbService9.IsEnabled = false;
            bService9.IsEnabled = false;
            bService9.Content = "";

            lbService10.IsEnabled = false;
            bService10.IsEnabled = false;
            bService10.Content = "";

            lbService11.IsEnabled = false;
            bService11.IsEnabled = false;
            bService11.Content = "";

            lbService12.IsEnabled = false;
            bService12.IsEnabled = false;
            bService12.Content = "";

            lbService13.IsEnabled = false;
            bService13.IsEnabled = false;
            bService13.Content = "";

            lbService14.IsEnabled = false;
            bService14.IsEnabled = false;
            bService14.Content = "";
            
        }

        private void EnabledHardware(ServerInfo.Server _server)
        {
            if (_server.Memory > 0)
            {
                lbMemory.IsEnabled = true;
                slideMemory.IsEnabled = true;
            }

               
            switch (_server.CPU)
            {
                case 4:
                    lbCPU4.IsEnabled = true;
                    slideCPU4.IsEnabled = true;
                    goto case 3;
                case 3:
                    lbCPU3.IsEnabled = true;
                    slideCPU3.IsEnabled = true;
                    goto case 2;
                case 2:
                    lbCPU2.IsEnabled = true;
                    slideCPU2.IsEnabled = true;
                    goto case 1;
                case 1:
                    lbCPU1.IsEnabled = true;
                    slideCPU1.IsEnabled = true;
                    break;
            }

            switch (_server.HDD)
            {
                case 4:
                    lbHDD4.IsEnabled = true;
                    slideHDD4.IsEnabled = true;
                    goto case 3;

                case 3:
                    lbHDD3.IsEnabled = true;
                    slideHDD3.IsEnabled = true;
                    goto case 2;
                
                case 2:
                    lbHDD2.IsEnabled = true;
                    slideHDD2.IsEnabled = true;
                    goto case 1;
                
                case 1:
                    lbHDD1.IsEnabled = true;
                    slideHDD1.IsEnabled = true;
                    break;
            }
        }

        private void EnabledServices(ServerInfo.Server _server)
        {

            List<ServerInfo.Service> services = wsServerInfo.GetServicesByServer(_server.Id);

            foreach (ServerInfo.Service service in services)
            {
                switch (service.Id)
                {
                    case 1:

                        lbService1.IsEnabled = true;
                        bService1.IsEnabled = true;
                        break;

                    case 2:

                        lbService2.IsEnabled = true;
                        bService2.IsEnabled = true;
                        break;

                    case 3:

                        lbService3.IsEnabled = true;
                        bService3.IsEnabled = true;
                        break;

                    case 4:

                        lbService4.IsEnabled = true;
                        bService4.IsEnabled = true;
                        break;

                    case 5:

                        lbService5.IsEnabled = true;
                        bService5.IsEnabled = true;
                        break;

                    case 6:

                        lbService6.IsEnabled = true;
                        bService6.IsEnabled = true;
                        break;

                    case 7:

                        lbService7.IsEnabled = true;
                        bService7.IsEnabled = true;
                        break;

                    case 8:

                        lbService8.IsEnabled = true;
                        bService8.IsEnabled = true;
                        break;

                    case 9:

                        lbService9.IsEnabled = true;
                        bService9.IsEnabled = true;
                        break;

                    case 10:

                        lbService10.IsEnabled = true;
                        bService10.IsEnabled = true;
                        break;

                    case 11:

                        lbService11.IsEnabled = true;
                        bService11.IsEnabled = true;
                        break;

                    case 12:

                        lbService12.IsEnabled = true;
                        bService12.IsEnabled = true;
                        break;

                    case 13:

                        lbService13.IsEnabled = true;
                        bService13.IsEnabled = true;
                        break;

                    case 14:

                        lbService14.IsEnabled = true;
                        bService14.IsEnabled = true;
                        break;
                }
            
            }
 
        }

        private void DisableAll()
        {
            lbTimeUpdate.IsEnabled = false;
            cbTimeUpdate.IsEnabled = false;
            lvServers.IsEnabled = false;
            gbHardware.IsEnabled = false;
            gbServerInfo.IsEnabled = false;
            gbServices.IsEnabled = false;

            lbServerName.Content = "";
            lbDNS.Content = "";
            lbIP.Content = "";
            lbMemoryServer.Content = "";
            lbCPU.Content = "";
            lbHDD.Content = "";
            lbDescription.Content ="";

            DisableHardwareAndServices();
        }

        private void EnableAll()
        {
            lbTimeUpdate.IsEnabled = true;
            cbTimeUpdate.IsEnabled = true;
            lvServers.IsEnabled = true;
            gbHardware.IsEnabled = true;
            gbServerInfo.IsEnabled = true;
            gbServices.IsEnabled = true;

            try
            {
                //Init App with all services and realtime

                    lvServers.ItemsSource = null;
            
                lvServers.ItemsSource = getAllServers();
                lvServers.SelectedItem = lvServers.Items.GetItemAt(0);
                InitializeServices();
                StartRealTime();
                UpdateServerSelected();
            }
            catch
            {
                MessageBox.Show("Error de connexió amb la base de dades");
                Close();
            }
        }

        private void StartRealTime()
        {

            List<ServerInfo.Server> _servers = wsServerInfo.GetAllActiveServers();
            List<ServerInfo.RealTime> _realTimes = new List<ServerInfo.RealTime>();

            wsServerInfo.DeleteRealTime();

            foreach (ServerInfo.Server server in _servers)
            {
                List<ServerInfo.Service> _services = wsServerInfo.GetServicesByServer(server.Id);

                foreach (ServerInfo.Service service in _services)
                {
                    
                    ServerInfo.RealTime rt = new ServerInfo.RealTime();

                    rt.ServerServiceId = wsServerInfo.GetServerServiceId(server.Id, service.Id);
                    
                    //if is service default is start
                    if (service.Id <= 101)
                    {  
                        rt.Status = 1;
                    }
                    else
                    {
                        rt.Status = 50;
                    }

                    //insert into realtime
                    _realTimes.Add(rt);
                }
            }

            wsServerInfo.InsertRealTimeList(_realTimes);
        }

        private void UpdateServerSelected()
        {
            if (lvServers.ItemsSource != null)
            {
                // AnalyzeRealTime();
                ServerInfo.Server server = new ServerInfo.Server();

                server = (ServerInfo.Server)lvServers.SelectedItem;
                server = wsServerInfo.GetServer(server.Id);

                //Update area with info server
                UpdateInfoServer(server);

                List<ServerInfo.RealTime> realtimesServer = wsServerInfo.GetRealTimeServer(server.Id);

                foreach (ServerInfo.RealTime rt in realtimesServer)
                {
                    switch (wsServerInfo.GetServiceOfServerAndServerServiceId(server.Id, rt.ServerServiceId))
                    {

                        case 1:

                            if (rt.Status.Equals(1))
                                bService1.Content = "Aturar";
                            else
                                bService1.Content = "Iniciar";
                            break;

                        case 2:

                            if (rt.Status.Equals(1))
                                bService2.Content = "Aturar";
                            else
                                bService2.Content = "Iniciar";
                            break;

                        case 3:

                            if (rt.Status.Equals(1))
                                bService3.Content = "Aturar";
                            else
                                bService3.Content = "Iniciar";
                            break;

                        case 4:

                            if (rt.Status.Equals(1))
                                bService4.Content = "Aturar";
                            else
                                bService4.Content = "Iniciar";
                            break;

                        case 5:

                            if (rt.Status.Equals(1))
                                bService5.Content = "Aturar";
                            else
                                bService5.Content = "Iniciar";
                            break;

                        case 6:

                            if (rt.Status.Equals(1))
                                bService6.Content = "Aturar";
                            else
                                bService6.Content = "Iniciar";
                            break;

                        case 7:

                            if (rt.Status.Equals(1))
                                bService7.Content = "Aturar";
                            else
                                bService7.Content = "Iniciar";
                            break;

                        case 8:

                            if (rt.Status.Equals(1))
                                bService8.Content = "Aturar";
                            else
                                bService8.Content = "Iniciar";
                            break;

                        case 9:

                            if (rt.Status.Equals(1))
                                bService9.Content = "Aturar";
                            else
                                bService9.Content = "Iniciar";
                            break;

                        case 10:

                            if (rt.Status.Equals(1))
                                bService10.Content = "Aturar";
                            else
                                bService10.Content = "Iniciar";
                            break;

                        case 11:

                            if (rt.Status.Equals(1))
                                bService11.Content = "Aturar";
                            else
                                bService11.Content = "Iniciar";
                            break;

                        case 12:

                            if (rt.Status.Equals(1))
                                bService12.Content = "Aturar";
                            else
                                bService12.Content = "Iniciar";
                            break;

                        case 13:

                            if (rt.Status.Equals(1))
                                bService13.Content = "Aturar";
                            else
                                bService13.Content = "Iniciar";
                            break;

                        case 14:

                            if (rt.Status.Equals(1))
                                bService14.Content = "Aturar";
                            else
                                bService14.Content = "Iniciar";
                            break;

                        case 101:

                            if (rt.Status == 1)
                                bNetwork.Content = "Desconnectar";
                            else
                                bNetwork.Content = "Connectar";
                            break;

                        case 102:

                            if (rt.Status > 0)
                                slideMemory.Value = rt.Status;
                            break;

                        case 103:

                            slideCPU1.Value = rt.Status;
                            break;

                        case 104:

                            slideCPU2.Value = rt.Status;
                            break;

                        case 105:

                            slideCPU3.Value = rt.Status;
                            break;

                        case 106:

                            slideCPU4.Value = rt.Status;
                            break;

                        case 107:

                            slideHDD1.Value = rt.Status;
                            break;

                        case 108:

                            slideHDD2.Value = rt.Status;
                            break;

                        case 109:

                            slideHDD3.Value = rt.Status;
                            break;

                        case 110:

                            slideHDD4.Value = rt.Status;
                            break;
                    }

                }
            }
        }

        private void UpdateStatusService(int _serverId, int _serviceId, int _status)
        {
            int serverServiceId =
                wsServerInfo.GetServerServiceId(_serverId, _serviceId);
            wsServerInfo.UpdatetRealTime(serverServiceId, _status);
        }

        private int GetServerId()
        {
            ServerInfo.Server server = new ServerInfo.Server();

            server = (ServerInfo.Server)lvServers.SelectedItem;

            return server.Id;
        }

        private void InstallService()
        {
            try
            {
                string pathInstall = @"C:\Windows\Microsoft.NET\Framework\v4.0.30319\installutil.exe";
                string pathService = Directory.GetCurrentDirectory() + "\\ServerMonitorWS.exe";
                pathService = pathService.Replace("ServerMonitorWPF", "ServerMonitorWS");

                Process service = new Process();
                ProcessStartInfo info = new ProcessStartInfo(pathInstall);
                info.Arguments = "\"" + pathService + "\"";
                info.WindowStyle = ProcessWindowStyle.Hidden;
                service = Process.Start(info);
            }
            catch (Exception e)
            {
                wsServerInfo.writeLog("Error al instalar el servei. " + e.ToString());
                MessageBox.Show("Error al instalar el servei.\n" + e.ToString());
            }
        }

        private void UninstallService()
        {
            try
            {
                string pathInstall = @"C:\Windows\Microsoft.NET\Framework\v4.0.30319\installutil.exe";
                string pathService = Directory.GetCurrentDirectory() + "\\ServerMonitorWS.exe";
                pathService = pathService.Replace("ServerMonitorWPF", "ServerMonitorWS");
                pathService = "\"" + pathService + "\"";
                pathService = pathService.Insert(0, "/u ");

                Process service = new Process();
                ProcessStartInfo info = new ProcessStartInfo(pathInstall);
                info.Arguments = pathService;
                info.WindowStyle = ProcessWindowStyle.Hidden;
                service = Process.Start(info);
            }
            catch (Exception e)
            {
                wsServerInfo.writeLog("Error al desinstalar el servei. " + e.ToString());
                MessageBox.Show("Error al desinstalar el servei\n" + e.ToString());
            }
        }

        private void StartService()
        {
            try
            {
                ServiceController service = new ServiceController();
                service.ServiceName = "ServerMonitor";
                service.Start();
                wsServerInfo.InsertAccessLogSystem("S'ha iniciat el servei de Windows");
            }
            catch(Exception e)
            {
                wsServerInfo.writeLog("Error al iniciar el servei. " + e.ToString());
                MessageBox.Show("Error al iniciar el servei\n" + e.ToString());
            }
        }

        private void StopService()
        {
            try
            {
                ServiceController service = new ServiceController();
                service.ServiceName = "ServerMonitor";
                service.Stop();
                wsServerInfo.InsertAccessLogSystem("S'ha aturat el servei de Windows");
            }
            catch (Exception e)
            {
                wsServerInfo.writeLog("Error al aturar el servei. " + e.ToString());
                //MessageBox.Show("Error al aturar el servei\n" + e.ToString());
            }
        }

        #endregion

        //Events
        #region Events

        private void bStart_Click(object sender, RoutedEventArgs e)
        {
            if (bStart.Content.Equals("Inicialitza entorn"))
            {
                bStart.Content = "Aturar monitorització";
                wsServerInfo.InsertAccessLogSystem("S'ininicialitza la monitorització WPF");
                InstallService();
                EnableAll();                
                StartService();                
            }
            else if (bStart.Content.Equals("Aturar monitorització"))
                {
                    bStart.Content = "Inicialitza la monitorització";
                    StopService();
                    DisableAll();
                    wsServerInfo.InsertAccessLogSystem("S'atura la monitorització WPF");
                }
                else if (bStart.Content.Equals("Inicialitza la monitorització"))
                    {
                        bStart.Content = "Aturar monitorització";
                        EnableAll();
                        StartService();

                        lbTimeUpdate.IsEnabled = true;
                        cbTimeUpdate.IsEnabled = true;
                        lvServers.IsEnabled = true;
                        gbHardware.IsEnabled = true;
                        gbServerInfo.IsEnabled = true;
                        gbServices.IsEnabled = true;
                        UpdateServerSelected();
                    }
        }

        private void lvServers_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            UpdateServerSelected();
        }

        private void cbTimeUpdate_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            wsServerInfo.UpdateTimeUpdate(Convert.ToInt32(cbTimeUpdate.SelectedValue));
        }

        private void bNetwork_Click(object sender, RoutedEventArgs e)
        {
            if (bNetwork.Content.Equals("Desconnectar"))
            {
                bNetwork.Content = "Connectar";
                UpdateStatusService(GetServerId(), 101, 0);

            }
            else
            {
                bNetwork.Content = "Desconnectar";
                UpdateStatusService(GetServerId(), 101, 1);
            }
        }

        private void slideMemory_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (slideMemory.IsEnabled)
                 UpdateStatusService(GetServerId(), 102, Convert.ToInt32(slideMemory.Value));
        }

        private void slideCPU1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (slideCPU1.IsEnabled)
                UpdateStatusService(GetServerId(), 103, Convert.ToInt32(slideCPU1.Value));
        }

        private void slideCPU2_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (slideCPU2.IsEnabled)
                 UpdateStatusService(GetServerId(), 104, Convert.ToInt32(slideCPU2.Value));
        }

        private void slideCPU3_ValueChanged_1(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (slideCPU3.IsEnabled)
                UpdateStatusService(GetServerId(), 105, Convert.ToInt32(slideCPU3.Value));
        }

        private void slideCPU4_ValueChanged_1(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (slideCPU4.IsEnabled)
                UpdateStatusService(GetServerId(), 106, Convert.ToInt32(slideCPU4.Value));
        }
    
        private void slideHDD1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (slideHDD1.IsEnabled)
                UpdateStatusService(GetServerId(), 107, Convert.ToInt32(slideHDD1.Value));
        }

        private void slideHDD2_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (slideHDD2.IsEnabled)
                UpdateStatusService(GetServerId(), 108, Convert.ToInt32(slideHDD2.Value));
        }

        private void slideHDD3_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (slideHDD3.IsEnabled)
                UpdateStatusService(GetServerId(), 109, Convert.ToInt32(slideHDD3.Value));
        }

        private void slideHDD4_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (slideHDD4.IsEnabled)
                UpdateStatusService(GetServerId(), 110, Convert.ToInt32(slideHDD4.Value));
        }

        private void bService1_Click(object sender, RoutedEventArgs e)
        {
            if (bService1.Content.Equals("Aturar"))
            {
                bService1.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 1, 0);
            }
            else
            {
                bService1.Content = "Aturar";
                UpdateStatusService(GetServerId(), 1, 1);
            }
        }

        private void bService2_Click(object sender, RoutedEventArgs e)
        {
            if (bService2.Content.Equals("Aturar"))
            {
                bService2.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 2, 0);
            }
            else
            {
                bService2.Content = "Aturar";
                UpdateStatusService(GetServerId(), 2, 1);
            }
        }

        private void bService3_Click(object sender, RoutedEventArgs e)
        {
            if (bService3.Content.Equals("Aturar"))
            {
                bService3.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 3, 0);
            }
            else
            {
                bService3.Content = "Aturar";
                UpdateStatusService(GetServerId(), 3, 1);
            }
        }

        private void bService4_Click(object sender, RoutedEventArgs e)
        {
            if (bService4.Content.Equals("Aturar"))
            {
                bService4.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 4, 0);
            }
            else
            {
                bService4.Content = "Aturar";
                UpdateStatusService(GetServerId(), 4, 1);
            }
        }

        private void bService5_Click(object sender, RoutedEventArgs e)
        {
            if (bService5.Content.Equals("Aturar"))
            {
                bService5.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 5, 0);
            }
            else
            {
                bService5.Content = "Aturar";
                UpdateStatusService(GetServerId(), 5, 1);
            }
        }

        private void bService6_Click(object sender, RoutedEventArgs e)
        {
            if (bService6.Content.Equals("Aturar"))
            {
                bService6.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 6, 0);
            }
            else
            {
                bService6.Content = "Aturar";
                UpdateStatusService(GetServerId(), 6, 1);
            }
        }

        private void bService7_Click(object sender, RoutedEventArgs e)
        {
            if (bService7.Content.Equals("Aturar"))
            {
                bService7.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 7, 0);
            }
            else
            {
                bService7.Content = "Aturar";
                UpdateStatusService(GetServerId(), 7, 1);
            }
        }

        private void bService8_Click(object sender, RoutedEventArgs e)
        {
            if (bService8.Content.Equals("Aturar"))
            {
                bService8.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 8, 0);
            }
            else
            {
                bService8.Content = "Aturar";
                UpdateStatusService(GetServerId(), 8, 1);
            }
        }

        private void bService9_Click(object sender, RoutedEventArgs e)
        {
            if (bService9.Content.Equals("Aturar"))
            {
                bService9.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 9, 0);
            }
            else
            {
                bService9.Content = "Aturar";
                UpdateStatusService(GetServerId(), 9, 1);
            }
        }

        private void bService10_Click(object sender, RoutedEventArgs e)
        {
            if (bService10.Content.Equals("Aturar"))
            {
                bService10.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 10, 0);
            }
            else
            {
                bService10.Content = "Aturar";
                UpdateStatusService(GetServerId(), 10, 1);
            }
        }

        private void bService11_Click(object sender, RoutedEventArgs e)
        {
            if (bService11.Content.Equals("Aturar"))
            {
                bService11.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 11, 0);
            }
            else
            {
                bService11.Content = "Aturar";
                UpdateStatusService(GetServerId(), 11, 1);
            }
        }

        private void bService12_Click(object sender, RoutedEventArgs e)
        {
            if (bService12.Content.Equals("Aturar"))
            {
                bService12.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 12, 0);
            }
            else
            {
                bService12.Content = "Aturar";
                UpdateStatusService(GetServerId(), 12, 1);
            }
        }

        private void bService13_Click(object sender, RoutedEventArgs e)
        {
            if (bService13.Content.Equals("Aturar"))
            {
                bService13.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 13, 0);
            }
            else
            {
                bService13.Content = "Aturar";
                UpdateStatusService(GetServerId(), 13, 1);
            }
        }

        private void bService14_Click(object sender, RoutedEventArgs e)
        {
            if (bService14.Content.Equals("Aturar"))
            {
                bService14.Content = "Iniciar";
                UpdateStatusService(GetServerId(), 14, 0);
            }
            else
            {
                bService14.Content = "Aturar";
                UpdateStatusService(GetServerId(), 14, 1);
            }
        }

        private void OpenWeb(object sender, RoutedEventArgs e)
        {
            string url = "http://localhost:1710/";
            Process service = new Process();
            ProcessStartInfo info = new ProcessStartInfo(url);
            service = Process.Start(info);
        }

        private void OpenServices(object sender, RoutedEventArgs e)
        {
            string services = "services.msc";
            Process service = new Process();
            ProcessStartInfo info = new ProcessStartInfo(services);
            service = Process.Start(info);
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            StopService();
            UninstallService();
            wsServerInfo.InsertAccessLogSystem("Es tanca la aplicació WPF");
        }

        private void Close_Window(object sender, RoutedEventArgs e)
        {
            StopService();
            UninstallService();
            wsServerInfo.InsertAccessLogSystem("Es tanca la aplicació WPF");
            Close();
        }

        private void AboutUsWindow(object sender, RoutedEventArgs e)
        {
            AboutUs _aboutUs = new AboutUs();

            _aboutUs.ShowDialog();
        }

        private void OpenHelp(object sender, RoutedEventArgs e)
        {
            String fileName = "Manual d'usuari.pdf";
            System.Diagnostics.Process process = new System.Diagnostics.Process();
            process.StartInfo.FileName = fileName;
            process.Start();
        }

        #endregion

    }
}
