﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ServerMonitorWeb.Account
{
    public partial class EditProfile : System.Web.UI.Page
    {

        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();

        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
            {
                Response.Redirect("~/Errors/Error.aspx");
            }

            if (!Page.IsPostBack)
            {
                try
                {
                    ServerInfo.User user = ws.GetUserById(Convert.ToInt32(Session["UserId"].ToString()));

                 //   Session["UserName"] = user.UserName.Trim();
                    UserName.Text = user.UserName.Trim();
                    Password2.Text = user.Password.Trim();
                    Password1.Text = user.Password.Trim();

                    tbUserName.Text = user.Name.Trim();
                    tbEmail.Text = user.Email.Trim();
                    cbEmail.Checked = (bool)user.SendEmail;
                    tbTwitter.Text = user.Twitter.Trim();
                    cbTwitter.Checked = (bool)user.SendTwitter;
                    tbSMS.Text = user.SMS.Trim();
                    cbSMS.Checked = (bool)user.SendSMS;
                    tbTelephone.Text = user.Telephone.Trim();
                }
                catch
                {
                    Response.Redirect("~/Errors/Error.aspx");
                }
            }

        }

        protected void EditUserButton_Click(object sender, EventArgs e)
        {
            ServerInfo.User user = new ServerInfo.User();
            ServerInfo.User realUser = ws.GetUserById(Convert.ToInt32(Session["UserId"].ToString()));

            user.Name = tbUserName.Text.Trim();
            user.UserName = UserName.Text.Trim();
            if (Password1.Text.Length > 0)
            {
                user.Password = Password1.Text.Trim();
            }
            user.Email = tbEmail.Text.Trim();
            if (tbEmail.Text.Trim().Length > 6)
                user.SendEmail = cbEmail.Checked;
            else
                user.SendEmail = false;

            user.Twitter = tbTwitter.Text.Trim();
            if (tbTwitter.Text.Trim().Length > 2)
                user.SendTwitter = cbTwitter.Checked;
            else
                user.SendTwitter = false;

            user.SMS = tbSMS.Text.Trim();
            if (tbSMS.Text.Trim().Length == 9)
                user.SendSMS = cbSMS.Checked;
            else
                user.SendSMS = false;
            user.Telephone = tbTelephone.Text.Trim();
            user.GroupId= realUser.GroupId;
            user.UserId = realUser.UserId;
            user.Comments = realUser.Comments;

            if (ws.EditUser(user))
            {
                ws.InsertAccessLog((int)Session["UserId"], "Ha modificat les seves dades.");
                Response.Write("<script>alert('Canvis realitzats correctament')</script>");
                Response.Redirect("~/Default.aspx");
            }
            else
            {
                lbResult.Text = "Error al modificar l'ususari";
                lbResult.ForeColor = System.Drawing.Color.Red;
            }
        }

        protected void bExit_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/Default.aspx");
        }
    }
}