﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ServerMonitorWeb.Account
{
    public partial class EventLog : System.Web.UI.Page
    {
        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();
        public List<ServerInfo.AccessLog> events = new List<ServerInfo.AccessLog>();

        protected void Page_Load(object sender, EventArgs e)
        {

            try
            {

                if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
                {
                    Response.Redirect("~/Errors/Error.aspx");
                }

                if (((int)Session["UserGroupId"]) == 1)

                    PanelSystemEvents.Visible = true;

                else
                    PanelSystemEvents.Visible = false;


                if (!Page.IsPostBack)
                {
                    List<ServerInfo.User> users = ws.GetAllUsers();

                    foreach (ServerInfo.User user in users)
                    {
                        ListItem it = new ListItem();
                        it.Value = user.UserId.ToString();
                        it.Text = user.Name;

                        ddlChangeUser.Items.Add(it);
                    }

                    ddlChangeUser.Items.FindByValue(Session["UserId"].ToString()).Selected = true;                    
                }

                events = ws.GetAccesLogByUserId(Convert.ToInt32(ddlChangeUser.SelectedValue));
                GridViewEvents.DataSource = events;
                GridViewEvents.DataBind();
            }
            catch
            {
               // ws.writeLog("Error al generar els registres d'events amb l'usuari " + Session["UserName"].ToString());
                ws.InsertAccessLog(Convert.ToInt32(Session["UserId"]), "Error al generar els registres d'events");
            }
        }


        protected void GViewEvents_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
                this.GridViewEvents.PageIndex = e.NewPageIndex;
                this.GridViewEvents.DataBind();     
        }        


        protected void ddlChangeUser_SelectedIndexChanged(object sender, EventArgs e)
        {
            events = ws.GetAccesLogByUserId(Convert.ToInt32(ddlChangeUser.SelectedValue));
            GridViewEvents.DataSource = events;
            GridViewEvents.DataBind();
            UpdatePanelLog.Update();
        }

    }
}