﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using ServerMonitorWeb.ServerInfo;

namespace ServerMonitorWeb.Account
{
    public partial class Login : System.Web.UI.Page
    {

        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void LoginButton_Click(object sender, EventArgs e)
        {
            ValidateForm();
        }

        private void ValidateForm()
        {
            bool validate = ws.VerifyUser(LoginUser.UserName, LoginUser.Password);

            if (validate)
            {
                Session["UserName"] = LoginUser.UserName;
                Session["UserLogged"] = "true";
                ServerInfo.User user = ws.GetUserByUsername(LoginUser.UserName);
                Session["UserGroupId"] = user.GroupId;
                Session["UserId"] = user.UserId;
                ws.InsertAccessLog(user.UserId, "Inici de sessió a aplicació Web");
                Response.Redirect("../Default.aspx");
            }
            else
            {
                Session["UserName"] = LoginUser.UserName;
                Session["UserLogged"] = "false";
                ws.InsertAccessLogSystem("Intent d'inici de sessió amb l'usuari " + LoginUser.UserName);
                lbNewPasswordResult.Text = "Usuari desconegut o desactivat. Introdueix un usuari vàlid.";
                lbNewPasswordResult.ForeColor = System.Drawing.Color.Red;
            }
        }

        protected void newPassword(object sender, EventArgs e)
        {
            bool ok = ws.NewPassword(LoginUser.UserName);

            if (ok)
            {
                lbNewPasswordResult.Text = "S'ha enviat un mail a la teva compte de correu amb una nova contrasenya";
                lbNewPasswordResult.ForeColor = System.Drawing.Color.Green;
                ServerInfo.User user = ws.GetUserByUsername(LoginUser.UserName);
                ws.InsertAccessLog(user.UserId, "S'ha enviat un nou password per solicitut de la web");
            }
            else
            {
                lbNewPasswordResult.Text = "Usuari desconegut o desactivat. Introdueix un usuari vàlid.";
                lbNewPasswordResult.ForeColor = System.Drawing.Color.Red;
            }
        }

    }
}
