﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Diagnostics;

namespace ServerMonitorWeb.Alerts
{
    public partial class Alerts : System.Web.UI.Page
    {

        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();
        
        protected void Page_Load(object sender, EventArgs e)
        {

            if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
            {
                Response.Redirect("~/Errors/Error.aspx");
            }

            if (Page.IsPostBack)
            {
                if (Convert.ToInt32(Request.Params["Id"]) > 0)
                {
                    showAlertDetail(Request.Params["Id"]);
                    AlertDetail.Visible = true;
                }
            }
            else
            {
                if (!Page.IsPostBack)
                {
                    ws.InsertAccessLog((int)Session["UserId"], "Entrada a la pàgina d'alertes");
                }
            }

            try
            {
                List<ServerInfo.vAlerts> alerts = ws.GetAlarmsUnreadByUserId(Convert.ToInt32(Session["UserId"].ToString()));

                gridViewAlerts.DataSource = alerts;
                gridViewAlerts.DataBind();
  
            }
            catch
            {
                Response.Redirect("~/Errors/Error.aspx");
            }
        }

        protected void gridViewAlerts_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
   
                ServerInfo.vAlerts alert = e.Row.DataItem as ServerInfo.vAlerts;

                ImageButton image = new ImageButton();

                if (alert.Status == 0)
                {
                    image.AlternateText = "No llegida";
                    image.ImageUrl = "~/img/Process-Warning.png";
                }     
                else
                {
                    image.AlternateText = "Llegida";
                    image.ImageUrl = "~/img/Process-Accept.png";
                }

                image.PostBackUrl = "./Alerts.aspx?Id=" + alert.Id.ToString();
                image.ImageAlign = ImageAlign.Middle;
                image.Width = 20;
                image.Height = 20;
               
                e.Row.Cells[1].Controls.Add(image);
  
            }
        }

        protected void upAlerts_Load(object sender, EventArgs e)
        {
            
            if (!gridViewAlerts.DataSource.Equals(null))
            {
                List<ServerInfo.vAlerts> alerts = ws.GetAlarmsUnreadByUserId(Convert.ToInt32(Session["UserId"].ToString()));
                gridViewAlerts.DataSource = alerts;
                gridViewAlerts.DataBind();
            }
        }

        protected void showAlertDetail(string _alertId)
        {
            ServerInfo.vAlert alarm = ws.GetAlarm(Convert.ToInt32(_alertId));

            if (alarm != null)
            {
                lbInstant.Text = alarm.Instant.ToString();
                lbServer.Text = alarm.Server.Trim();
                lbServerAlarts.Text = alarm.ServerAlerts.ToString();
                lbService.Text = alarm.Service.Trim();
                lbServiceAlerts.Text = alarm.ServiceAlerts.ToString();
                lbName.Text = alarm.OwnerName.Trim();
                hlEmail.Text = alarm.OwnerEmail.Trim();
                hlEmail.NavigateUrl = "mailto:" + alarm.OwnerEmail.Trim();
                lbTelephone.Text = alarm.OwnerTlf;
                lbSolution.Text = alarm.Solution;
               
                if (alarm.Status != 0)
                {
                    bReadAlert.Enabled = false;
                }

                 ws.InsertAccessLog((int)Session["UserId"], "Visió de la alerta " +
                                    _alertId + " del servidor " + alarm.Server + 
                                    " del servei " + alarm.Service);                
            }
        }

        protected void bReadAlert_Click(object sender, EventArgs e)
        {
            ws.ReadAlarm(Convert.ToInt32(Request.Params["Id"].ToString()));
            AlertDetail.Visible = false;

            ws.InsertAccessLog((int)Session["UserId"], "Marcar la alerta " +
                    Request.Params["Id"].ToString() + " com llegida.");  

            Response.Redirect(Request.RawUrl);
        }

        protected void GViewAlerts_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            this.gridViewAlerts.PageIndex = e.NewPageIndex;
            this.gridViewAlerts.DataBind();
            AlertDetail.Visible = false;
        }

    }
}