﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ServerMonitorWeb.Config.Alerts
{
    public partial class EditService : System.Web.UI.Page
    {
        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();

        protected void Page_Load(object sender, EventArgs e)
        {
           
            if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
            {
                Response.Redirect("~/Errors/Error.aspx");
            }

            try
            {
                if (!Page.IsPostBack)
                {
                    ServerInfo.Service service = ws.GetService(Convert.ToInt32(Request.Params["Id"]));
                    subTitle.Text += service.Name;
                    tbName.Text = service.Name.Trim();
                    tbDescription.Text = service.Description.Trim();
                    tbRessolution.Text = service.Ressolution.Trim();
                }
            }
            catch
            {
                Response.Redirect("~/Errors/Error.aspx");
            }
        }

        protected void bSave_Click(object sender, EventArgs e)
        {
            try
            {
                ServerInfo.Service service = new ServerInfo.Service();

                service.Id = Convert.ToInt32(Request.Params["Id"]);
                service.Name = tbName.Text.Trim();
                service.Description = tbDescription.Text.Trim();
                service.Ressolution = tbRessolution.Text.Trim();

                if (ws.UpdateService(service))
                {
                    lbResult.ForeColor = System.Drawing.Color.Green;
                    lbResult.Text = "S'ha modificat correctament";
                    ws.InsertAccessLog((int)Session["UserId"], "S'ha modificat la alerta " + service.Name); 
                }
                else
                {
                    lbResult.ForeColor = System.Drawing.Color.Red;
                    lbResult.Text = "S'ha produit un error al modificar el servei a la base de dades";
                }
            }
            catch
            {
                lbResult.ForeColor = System.Drawing.Color.Red;
                lbResult.Text = "S'ha produit un error al modificar el servei a la base de dades";
            }
        }

        protected void bExit_Click(object sender, EventArgs e)
        {
            Response.Redirect("./ConfigAlerts.aspx");
        }


    }
}