﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ServerMonitorWeb.Config.Users
{
    public partial class ConfigUsers : System.Web.UI.Page
    {
        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();

        protected void Page_Load(object sender, EventArgs e)
        {

            if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
            {
                Response.Redirect("~/Errors/Error.aspx");
            }

            try
            {
                List<ServerInfo.vUsers> users = ws.GetViewUsers();

                GridViewUsers.DataSource = users;
                GridViewUsers.DataBind();
            }
            catch
            {
                Response.Redirect("~/Errors/Error.aspx");
            }
        }

        protected void GridViewUsers_RowDataBound(object sender, GridViewRowEventArgs e)
        {

            if (e.Row.RowType == DataControlRowType.DataRow)
            {

                ServerInfo.vUsers user = e.Row.DataItem as ServerInfo.vUsers;

                // User

                Label _user = new Label();

                _user.Text = user.Name;
                e.Row.Cells[1].Controls.Add(_user);

                 // GroupName

                Label _group = new Label();

                _group.Text = user.Group;
                e.Row.Cells[2].Controls.Add(_group);

                // Status
                ImageButton image = new ImageButton();
                Button _disable = new Button();

                if (user.EndDate.Equals(new DateTime(2001, 01, 01)))
                {
                    image.AlternateText = "Actiu";
                    image.ImageUrl = "~/img/User-Green.png";

                    _disable.Text = "Deshabilitar usuari";
                    _disable.CommandArgument = user.Username;
                    _disable.Command += new CommandEventHandler(this._disable_Click);
                }
                else
                {
                    image.AlternateText = "Baixa";
                    image.ImageUrl = "~/img/User-Red.png";

                    _disable.Text = "Habilitar usuari";
                    _disable.CommandArgument = user.Username;
                    _disable.Command += new CommandEventHandler(this._enabled_Click);
                }

                image.ImageAlign = ImageAlign.Middle;
                image.Width = 20;
                image.Height = 20;

                e.Row.Cells[3].Controls.Add(image);


                // UserName

                Label _username = new Label();

                _username.Text = user.Username;
                e.Row.Cells[4].Controls.Add(_username);


                // Modify

                Button _modify = new Button();

                _modify.Text = "Modificar";
                _modify.CommandArgument = user.UserId.ToString();
                _modify.Command += new CommandEventHandler(this._modify_Click);
                e.Row.Cells[5].Controls.Add(_modify);

                // Reset Password

                Button _resetPassword = new Button();

                _resetPassword.Text = "Restablir contrasenya";
                _resetPassword.CommandArgument = user.Username;
                _resetPassword.Command += new CommandEventHandler(this._resetPassword_Click);

                e.Row.Cells[6].Controls.Add(_resetPassword);

                // Disable User

                e.Row.Cells[7].Controls.Add(_disable);
            }
        }

        protected void _modify_Click(object sender, CommandEventArgs e)
        {
           Response.Redirect("./EditUser.aspx?id=" + e.CommandArgument.ToString());
        }

        protected void _resetPassword_Click(object sender, CommandEventArgs e)
        {

            if (ws.NewPassword(e.CommandArgument.ToString()))
            {
                lbInfo.Text =  "S'ha enviat una nova contrasenya al usuari " + e.CommandArgument.ToString();
                lbInfo.ForeColor = System.Drawing.Color.Green;
                ws.InsertAccessLog((int)Session["UserId"], "Ha generat una nova contrasenya al usuari " + e.CommandArgument); 
            }
            else
            {
                lbInfo.Text = "Error al restablir la contrasenya per l'usuari " + e.CommandArgument.ToString();
                lbInfo.ForeColor = System.Drawing.Color.Red;
            }
        }

        protected void _disable_Click(object sender, CommandEventArgs e)
        {
            if (ws.DisableUser(e.CommandArgument.ToString()))
            {
                lbInfo.Text =  "L''usuari " + e.CommandArgument + " s'ha deshabilitat";
                lbInfo.ForeColor = System.Drawing.Color.Green;
                ws.InsertAccessLog((int)Session["UserId"], "Ha deshabilitat el usuari " + e.CommandArgument); 
            }
            else
            {
                lbInfo.Text = "Error al deshabilitar l'usuari " + e.CommandArgument.ToString();
                lbInfo.ForeColor = System.Drawing.Color.Red;
            }
            Response.Redirect(Request.RawUrl);
        }

        protected void _enabled_Click(object sender, CommandEventArgs e)
        {
            if (ws.EnabledUser(e.CommandArgument.ToString()))
            {
                lbInfo.Text = "L''usuari " + e.CommandArgument + " s'ha habilitat correctament";
                lbInfo.ForeColor = System.Drawing.Color.Green;
                ws.InsertAccessLog((int)Session["UserId"], "Ha habilitat el usuari " + e.CommandArgument); 
            }
            else
            {
                lbInfo.Text = "Error al habilitar l'usuari " + e.CommandArgument.ToString();
                lbInfo.ForeColor = System.Drawing.Color.Red;
            }
            Response.Redirect(Request.RawUrl);
        }

        protected void bNewUser_Click(object sender, EventArgs e)
        {
            Response.Redirect("./NewUser.aspx");
        }

    }
}