﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ServerMonitorWeb.Config.Users
{
    public partial class EditUser : System.Web.UI.Page
    {

        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();

        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
            {
                Response.Redirect("~/Errors/Error.aspx");
            }
            
            if (!Page.IsPostBack)
            {
                try
                {
                    List<ServerInfo.UserGroup> groups = ws.GetAllUserGroups();

                    foreach (ServerInfo.UserGroup group in groups)
                    {
                        ListItem item = new ListItem(group.Name, group.GroupId.ToString());
                        ddlUserGroup.Items.Add(item);
                    }

                    ServerInfo.User user = ws.GetUserById(Convert.ToInt32(Request.Params["id"]));

                    Session["NewUserName"] = user.UserName.Trim();
                    UserName.Text = user.UserName.Trim();
                    Password2.Text = user.Password.Trim();
                    Password1.Text = user.Password.Trim();

                    tbUserName.Text = user.Name.Trim();
                    tbEmail.Text = user.Email.Trim();
                    cbEmail.Checked = (bool)user.SendEmail;
                    tbTwitter.Text = user.Twitter.Trim();
                    cbTwitter.Checked = (bool)user.SendTwitter;
                    tbSMS.Text = user.SMS.Trim();
                    cbSMS.Checked = (bool)user.SendSMS;
                    tbTelephone.Text = user.Telephone.Trim();
                    lbStartDate.Text = "Data de creació: " + user.StartDate.ToString();

                    ddlUserGroup.Items.FindByValue(user.GroupId.ToString()).Selected = true;
                    tbComments.Text = user.Comments.Trim();

                }
                catch
                {
                    Response.Redirect("~/Errors/Error.aspx");
                }
            }

        }

        protected void EditUserButton_Click(object sender, EventArgs e)
        {
            ServerInfo.User user = new ServerInfo.User();

            user.Name = tbUserName.Text.Trim();
            user.UserName = UserName.Text.Trim();
            if (Password1.Text.Length > 0)
            {
                user.Password = Password1.Text.Trim();
            }
            user.Email = tbEmail.Text.Trim();
            if (tbEmail.Text.Trim().Length > 6)
                user.SendEmail = cbEmail.Checked;
            else
                user.SendEmail = false;

            user.Twitter = tbTwitter.Text.Trim();
            if (tbTwitter.Text.Trim().Length > 2)
                user.SendTwitter = cbTwitter.Checked;
            else
                user.SendTwitter = false;

            user.SMS = tbSMS.Text.Trim();
            if (tbSMS.Text.Trim().Length == 9)
                user.SendSMS = cbSMS.Checked;
            else
                user.SendSMS = false;

            user.Telephone = tbTelephone.Text.Trim();
            user.GroupId = Convert.ToInt32(ddlUserGroup.SelectedItem.Value);
            user.Comments = tbComments.Text.Trim();

            if (ws.EditUser(user))
            {
                ws.InsertAccessLog((int)Session["UserId"], "Ha modificat el usuari " + user.UserId + " - " + user.Name); 
                Response.Write("<script>alert('Canvis realitzats correctament')</script>");
                Response.Redirect("./ConfigUsers.aspx");
            }
            else
            {
                lbResult.Text = "Error al modificar l'ususari";
                lbResult.ForeColor = System.Drawing.Color.Red;
            }
        }

        protected void bPermissions_Click(object sender, EventArgs e)
        {
            Response.Redirect("./Permissions.aspx");
        }
    }
}