﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ServerMonitorWeb.Config.Users
{
    public partial class NewUser : System.Web.UI.Page
    {

        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();

        protected void Page_Load(object sender, EventArgs e)
        {

            if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
            {
                Response.Redirect("~/Errors/Error.aspx");
            }

 
            List<ServerInfo.UserGroup> groups = ws.GetAllUserGroups();

            foreach (ServerInfo.UserGroup group in groups)
            {
                ListItem item = new ListItem(group.Name, group.GroupId.ToString());
                ddlUserGroup.Items.Add(item);
            }
        }

        protected void NewUserButton_Click(object sender, EventArgs e)
        {
            ServerInfo.User user = new ServerInfo.User();

            user.Name = tbUserName.Text.Trim();
            user.UserName = UserName.Text.Trim();
            user.Password = Password1.Text.Trim();
            user.Email = tbEmail.Text.Trim();
            if (tbEmail.Text.Trim().Length > 6)
                user.SendEmail = cbEmail.Checked;
            else
                user.SendEmail = false;

            user.Twitter = tbTwitter.Text.Trim();
            if (tbTwitter.Text.Trim().Length > 2)
                user.SendTwitter = cbTwitter.Checked;
            else
                user.SendTwitter = false;

            user.SMS = tbSMS.Text.Trim();
            if (tbSMS.Text.Trim().Length == 9)
                user.SendSMS = cbSMS.Checked;
            else
                user.SendSMS = false;

            user.Telephone = tbTelephone.Text.Trim();
            user.GroupId = Convert.ToInt32(ddlUserGroup.SelectedItem.Value);
            user.Comments = tbComments.Text.Trim();

            if (ws.AddUser(user))
            {
                bPermissions.Enabled = true;
                bPermissions.Focus();
                DisableAll();
                lbResult.Text = "Usuari introdut correctament";
                lbResult.ForeColor = System.Drawing.Color.Green;
                ws.InsertAccessLog((int)Session["UserId"], "Ha creat el usuari " + user.Name); 
                //Save new user for to avoid one more query or access to WS
                Session["NewUserName"] = UserName.Text;

            }
            else
            {
                bPermissions.Enabled = false;
                NewUserButton.Enabled = true;
                lbResult.Text = "L'usuari ja existeix";
                lbResult.ForeColor = System.Drawing.Color.Red;
            }
        }

        protected void bPermissions_Click(object sender, EventArgs e)
        {

            Response.Redirect("./Permissions.aspx");
        }

        private void DisableAll()
        {
            tbUserName.Enabled = false;
            UserName.Enabled = false;
            Password1.Enabled = false;
            Password2.Enabled = false;
            tbEmail.Enabled = false;
            tbTwitter.Enabled = false;
            tbSMS.Enabled = false;
            tbTelephone.Enabled = false;
            ddlUserGroup.Enabled = false;
            tbComments.Enabled = false;
            NewUserButton.Enabled = false;
        }

    }
}