﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ServerMonitorWeb.Config.Users
{
    public partial class Permissions : System.Web.UI.Page
    {

        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();
        

        protected void Page_Load(object sender, EventArgs e)
        {

            if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
            {
                Response.Redirect("~/Errors/Error.aspx");
            }

            if (!Page.IsPostBack)
            {
          
                List<int> unassigned = new List<int>();
                Session["unassigned"] = unassigned;

                List<int> assigned = new List<int>();
                Session["assigned"] = assigned;

                ServerInfo.User user = ws.GetUserByUsername(Session["NewUserName"].ToString());
                Session["NewUserId"] = user.UserId;
                subTitle.Text = "Permisos del usuari " + user.UserName;

                List<ServerInfo.Server> servers = ws.GetAllServers();

                foreach (ServerInfo.Server server in servers)
                {
                    ListItem item = new ListItem(server.Name, server.Id.ToString());
                    ddlServers.Items.Add(item);
                }

                UpdateListsBox(Convert.ToInt32(ddlServers.SelectedValue.ToString()), user.UserId);
            }
           
        }

        protected void UpdateListsBox(int _serverId, int _userId)
        {

            listboxServicesUnassigned.Items.Clear();
            listboxServicesAssigned.Items.Clear();

            List<ServerInfo.vPermission> unassignements = ws.GetServicesUnassigned(_serverId, _userId);

            foreach (ServerInfo.vPermission upermission in unassignements)
            {
                ListItem item = new ListItem(upermission.ServerServiceName, upermission.ServerServiceId.ToString());
                if (((List<int>)Session["assigned"]).Contains(upermission.ServerServiceId))
                {
                    listboxServicesAssigned.Items.Add(item); 
                }
                else
                {
                    listboxServicesUnassigned.Items.Add(item);
                }
            }

            List<ServerInfo.vPermission> assignements = ws.GetServicesAssigned(_serverId, _userId);

            foreach (ServerInfo.vPermission permission in assignements)
            {
                ListItem item = new ListItem(permission.ServerServiceName, permission.ServerServiceId.ToString());
                if ( ((List<int>)Session["unassigned"]).Contains(permission.ServerServiceId))
                {
                    listboxServicesUnassigned.Items.Add(item);
                }
                else
                {
                    listboxServicesAssigned.Items.Add(item);
                }
            }
        }

        protected void ddlServers_SelectedIndexChanged(object sender, EventArgs e)
        {

            foreach (ListItem item in listboxServicesUnassigned.Items)
            {
                if (!((List<int>)Session["unassigned"]).Contains(Convert.ToInt32(item.Value)))
                {
                    ((List<int>)Session["unassigned"]).Add(Convert.ToInt32(item.Value));
                }
            }

            foreach (ListItem item in listboxServicesAssigned.Items)
            {
                if (!((List<int>)Session["assigned"]).Contains(Convert.ToInt32(item.Value)))
                {
                    ((List<int>)Session["assigned"]).Add(Convert.ToInt32(item.Value));
                }
            }

            UpdateListsBox(Convert.ToInt32(ddlServers.SelectedValue.ToString()), Convert.ToInt32(Session["NewUserId"].ToString()));
        }

        protected void AddAll(object sender, EventArgs e)
        {
            List<ListItem> remove = new List<ListItem>();
            foreach (ListItem item in listboxServicesUnassigned.Items)
            {
                listboxServicesAssigned.Items.Add(item);
                remove.Add(item);
            }
        
            foreach (ListItem item in remove)
            {
                listboxServicesUnassigned.Items.Remove(item);
            }
        }

        protected void RemoveAll(object sender, EventArgs e)
        {
            List<ListItem> remove = new List<ListItem>();
            foreach (ListItem item in listboxServicesAssigned.Items)
            {
                listboxServicesUnassigned.Items.Add(item);
                remove.Add(item);
            }

            foreach (ListItem item in remove)
            {
                listboxServicesAssigned.Items.Remove(item);
            }
        }

        protected void AddOne(object sender, EventArgs e)
        {
            if (listboxServicesUnassigned.SelectedItem != null)
            {
                ListItem item = listboxServicesUnassigned.SelectedItem;
                listboxServicesAssigned.Items.Add(item);
                listboxServicesUnassigned.Items.FindByValue(item.Value).Selected = false;
                listboxServicesUnassigned.Items.Remove(item);
            }
        }

        protected void RemoveOne(object sender, EventArgs e)
        {
            if (listboxServicesAssigned.SelectedItem != null)
            {
                ListItem item = listboxServicesAssigned.SelectedItem;
                listboxServicesUnassigned.Items.Add(item);
                listboxServicesAssigned.Items.FindByValue(item.Value).Selected = false;
                listboxServicesAssigned.Items.Remove(item);
            }
        }

        protected void Save(object sender, EventArgs e)
        {

            foreach (ListItem item in listboxServicesUnassigned.Items)
            {
                if (!((List<int>)Session["unassigned"]).Contains(Convert.ToInt32(item.Value)))
                {
                    ((List<int>)Session["unassigned"]).Add(Convert.ToInt32(item.Value));
                }
            }

            foreach (ListItem item in listboxServicesAssigned.Items)
            {
                if (!((List<int>)Session["assigned"]).Contains(Convert.ToInt32(item.Value)))
                {
                    ((List<int>)Session["assigned"]).Add(Convert.ToInt32(item.Value));
                }
            }

            if (ws.UpdatePermissions(Convert.ToInt32(Session["NewUserId"].ToString()), ((List<int>)Session["unassigned"]), ((List<int>)Session["assigned"])))
            {
                ws.InsertAccessLog((int)Session["UserId"], "Ha modificat els permisos del usuari " + Session["NewUserId"].ToString()); 
                Response.Write("<script>alert('Canvis realitzats correctament')</script>");
                Response.Redirect("./ConfigUsers.aspx");
            }
            else
            {
                lbResult.Text = "S'ha produit un error al grabar els permisos";
                lbResult.ForeColor = System.Drawing.Color.Red;
            }
        }

        protected void Exit(object sender, EventArgs e)
        {
            Response.Redirect("./ConfigUsers.aspx");
        }
    }
}