﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="ServerDetail.aspx.cs" Inherits="ServerMonitorWeb.Servers.ServerDetail" %>
<asp:Content ID="Content1" ContentPlaceHolderID="HeadContent" runat="server">

    <script type="text/javascript" src="../Scripts/jquery-1.7.1.min.js"></script>
    <script type="text/javascript" src="../Scripts/highcharts.js"></script>
    <script type="text/javascript" src="../Scripts/exporting.js"></script>
    <script type="text/javascript">
        $(function () {
            var chart;
            $(document).ready(function () {
                chart = new Highcharts.Chart({
                    chart: {
                        renderTo: 'hardwareGraph',
                        type: 'line',
                        marginRight: 130,
                        marginBottom: 25
                    },
                    title: {
                        text: 'Hardware',
                        x: -20 //center
                    },
                    subtitle: {
                        text: ' ',
                        x: -20
                    },
                    xAxis: {
                        categories: [<%=timeHrd %>]
                    },
                    yAxis: {
                        title: {
                            text: ' '
                        },
                        plotLines: [{
                            value: 0,
                            width: 1,
                            color: '#808080'
                        }]
                    },
                    tooltip: {
                        formatter: function () {
                            return '<b>' + this.series.name + '</b><br/>' + this.x + ': ' + this.y;
                        }
                    },
                    legend: {
                        layout: 'vertical',
                        align: 'right',
                        verticalAlign: 'top',
                        x: -10,
                        y: 100,
                        borderWidth: 0
                    },
                    series: [{
                        name: '<%=serviceNameHrd %>',
                        data: [<%=statusHrd %>]
                    }]
                });
            });
        });
        </script>

        <script type="text/javascript">
        $(function () {
            var chart;
            $(document).ready(function () {
                chart = new Highcharts.Chart({
                    chart: {
                        renderTo: 'serviceGraph',
                        type: 'line',
                        marginRight: 130,
                        marginBottom: 25
                    },
                    title: {
                        text: 'Servei',
                        x: -20 //center
                    },
                    subtitle: {
                        text: ' ',
                        x: -20
                    },
                    xAxis: {
                        categories: [<%=timeSrv %>]
                    },
                    yAxis: {
                        title: {
                            text: ' '
                        },
                        plotLines: [{
                            value: 0,
                            width: 1,
                            color: '#808080'
                        }]
                    },
                    tooltip: {
                        formatter: function () {
                            return '<b>' + this.series.name + '</b><br/>' + this.x + ': ' + this.y;
                        }
                    },
                    legend: {
                        layout: 'vertical',
                        align: 'right',
                        verticalAlign: 'top',
                        x: -10,
                        y: 100,
                        borderWidth: 0
                    },
                    series: [{
                        name: '<%=serviceNameSrv %>',
                        data: [<%=statusSrv %>]
                    }]
                });
            });
        });
    </script>

</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
    <asp:ScriptManager ID="ScriptManagerUP" runat="server" />
    <div class="titlePage">
        <h2>
           <asp:Image ID="ImgLogin" runat="server" Height="80px" 
                ImageUrl="~/img/Home-Server.png" Width="80px" />
           <asp:Label ID="lbServerName" runat="server" Text="<ServerName>" />
        </h2>
        <p></p>
    </div>
    <div class="w900">
    <fieldset class="listServers">  
        <legend>Informació del servidor</legend>
        <table>
            <tr>
                <td>Nom: </td>                
                <td class="w200">
                    <asp:Label ID="lbServerNameDetail" runat="server" />
                </td>
                <td>Zona: </td>
                <td class="w200">
                    <asp:Label ID="lbZone" runat="server" />
                </td>
                <td>Alarmes en curs: </td>
                <td class="w200">
                    <asp:Label ID="lbCurrentAlarms" runat="server" />
                </td>
            </tr>
            <tr>
                <td>DNS: </td>
                <td class="w200">
                    <asp:Label ID="lbDNS" runat="server" />
                </td>
                <td>Critic: </td>
                <td class="w200">
                    <asp:Label ID="lbCritic" runat="server" />
                </td>
                <td>Total d'alarmes: </td>
                <td class="w200">
                    <asp:Label ID="lbTotalAlarms" runat="server" />
                </td>
            </tr>
            <tr>
                <td valign="top">Ip: </td>
                <td class="w200" valign="top">
                    <asp:Label ID="lbIP" runat="server" />
                </td>
                <td valign="top">Responsable: </td>
                <td class="w200" valign="top">
                    <asp:Label ID="lbOwner" runat="server"  />
                </td>
                <td valign="top">Última alarma: </td>
                <td class="w200" valign="top">
                    <asp:Label ID="lbLastAlarm" runat="server" />
                </td>
            </tr>
            <tr >
                <td colspan="2" align="right" valign="top">Descripció del servidor: </td>
                <td colspan="3" align="left" valign="top">
                    <asp:Label ID="lbDescription" runat="server" />
                </td>
                <td></td>
            </tr>
        </table>
    </fieldset>

    <asp:Table ID="serverOnline" runat="server">
        <asp:TableRow>
            <asp:TableCell>
                <fieldset runat="server" class="fieldSetServerDetail">
                    <legend> Hardware </legend>
                    <asp:Table runat="server" ID="tableHardware">
                    </asp:Table>
                </fieldset>
            </asp:TableCell>
            <asp:TableCell HorizontalAlign="Center" VerticalAlign="Middle">
                <asp:UpdatePanel ID="UpdatePanelHardwareGraph" runat="server" UpdateMode="Conditional">  
                    <ContentTemplate>
                        <div id="hardwareGraph" style="min-width: 600px; height: 220px; margin: 0 auto" />
                    </ContentTemplate>              
                </asp:UpdatePanel>
            </asp:TableCell>
        </asp:TableRow>
        <asp:TableRow>
            <asp:TableCell>
                <fieldset runat="server" class="fieldSetServerDetail">
                    <legend> Serveis </legend>
                    <asp:Table runat="server" ID="tableServices">
                    </asp:Table>
                </fieldset>
            </asp:TableCell>
            <asp:TableCell HorizontalAlign="Center" VerticalAlign="Middle">
                <asp:UpdatePanel ID="UpdatePanelServiceGraph" runat="server" UpdateMode="Conditional">  
                    <ContentTemplate>
                            <div id="serviceGraph" style="min-width: 600px; height: 220px; margin: 0 auto" />
                    </ContentTemplate>              
                </asp:UpdatePanel>
            </asp:TableCell>
        </asp:TableRow>
    </asp:Table>

    </div>
</asp:Content>
