﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;


namespace ServerMonitorWeb.Servers
{
    public partial class ServerDetail : System.Web.UI.Page
    {
        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();

        public string timeHrd;
        public string statusHrd;
        public string serviceNameHrd;
        public string timeSrv;
        public string statusSrv;
        public string serviceNameSrv;

        protected void Page_Load(object sender, EventArgs e)
        {
       
            if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
            {
                Response.Redirect("~/Errors/Error.aspx");
            }
            try
            {

                if (Convert.ToInt32(Request.Params["Hrd"]) != 0)
                    GenerateGraphHrd();
                else
                {
                    timeHrd = "";
                    statusHrd = "";
                    serviceNameHrd = "Component";
                }

                if (Convert.ToInt32(Request.Params["Srv"]) != 0)
                    GenerateGraphSrv();
                else
                {

                    timeSrv = "";
                    statusSrv = "";
                    serviceNameSrv = "Servei";
                }

                Info(Convert.ToInt32(Request.Params["Id"]), Convert.ToInt32(Session["UserId"]));
                RealTime(Convert.ToInt32(Request.Params["Id"]), Convert.ToInt32(Session["UserId"].ToString()));

                if (!Page.IsPostBack)
                {
                    ws.InsertAccessLog((int)Session["UserId"],
                                       "Entrada a la pàgina del servidor " + (ws.GetServer(Convert.ToInt32(Request.Params["Id"]))).Name);
                }
            }
            catch
            {
                Response.Redirect("~/Errors/Error.aspx");
            }


        }

        protected void Info(int _serverId, int _userId)
        {
            try
            {
                ServerInfo.vServer server = ws.GetViewServer(_serverId, _userId);

                lbServerName.Text = server.Name;

                lbServerNameDetail.Text = server.Name;
                lbZone.Text = server.Zone;
                lbCurrentAlarms.Text = server.CurrentAlarms.ToString();
                lbDNS.Text = server.DNS;
                lbCritic.Text = server.Critic.ToString();
                lbTotalAlarms.Text = server.TotalAlarms.ToString();
                lbIP.Text = server.IP;
                lbOwner.Text = server.OwnerName + " - " + server.OwnerEmail + " - " + server.OwnerPhone;
                lbLastAlarm.Text = server.LastAlarm.ToString();
                lbDescription.Text = server.Description;

            }
            catch
            {
                Response.Redirect("~/Errors/Error.aspx");
            }
        }

        protected void RealTime(int _serverId, int _userId)
        {

            List<ServerInfo.vRealTimeServer> rt = new List<ServerInfo.vRealTimeServer>();
            rt = ws.GetViewRealTimeServer(_serverId, _userId);
            
            int statusCPU = 0, statusHDD = 0, maxHDD = 0;
            string serviceCPU = "", serviceHDD = "";

            if (!rt.Equals(null))
            {
                #region foreach
                foreach (ServerInfo.vRealTimeServer service in rt)
                {
                    TableRow tr= new TableRow();

                    TableCell cellName = new TableCell();
                    TableCell cellStatus = new TableCell();
                    TableCell cellButton = new TableCell();

                    cellName.Height = 30;
                    cellName.Width = 130;
                    cellName.HorizontalAlign = HorizontalAlign.Left;

                    cellStatus.Width = 100;
                    cellStatus.HorizontalAlign = HorizontalAlign.Left;

                    cellButton.Width = 20;
                    cellButton.HorizontalAlign = HorizontalAlign.Center;


                    #region services

                    if (service.ServiceId < 100)
                    {

                        cellName.Text = service.ServiceName.Trim() + ": ";
                        cellName.Width = 130;

                        Image status = new Image();
                        status.Height = 30;
                        status.Width = 30;

                        if (service.Status == 0)
                        {
                            status.ImageUrl = "~/img/Process-Warning.png";
                            status.ToolTip = "Servei aturat";
                            status.AlternateText = "Servei aturat";
                        }
                        else
                        {
                            status.ImageUrl = "~/img/Process-Accept.png";
                            status.ToolTip = "Servei iniciat";
                            status.AlternateText = "Servei iniciat";
                        }

                        cellStatus.Controls.Add(status);
                        cellStatus.Width = 100;

                        ImageButton bt = new ImageButton();
                        
                        bt.ID = "bt_" + service.ServiceId.ToString();
                      //  bt.PostBackUrl = GetUrlReload(_serverId, _userId, Request.QueryString["Hrd"].ToString(), service.ServiceId.ToString());
                        bt.ImageUrl = "~/img/Line-chart.png";
                        bt.Click += bServiceClick;
                                            
                        cellButton.Controls.Add(bt);

                        tr.Cells.Add(cellName);
                        tr.Cells.Add(cellStatus);
                        tr.Cells.Add(cellButton);

                        tableServices.Rows.Add(tr);
                    }

                    #endregion

                    #region hardware
                    else
                    {
                        //Network
                        if (service.ServiceId == 101)
                        {
                            cellName.Text = service.ServiceName.Trim() + ": ";
                            
                            Image status = new Image();
                            status.Height = 30;
                            status.Width = 30;

                            if (service.Status == 0)
                            {
                                status.ImageUrl = "~/img/Process-Warning.png";
                                status.ToolTip = "Desconnectat";
                                status.AlternateText = "Desconnectat";
                            }
                            else
                            {
                                status.ImageUrl = "~/img/Process-Accept.png";
                                status.ToolTip = "Connectat";
                                status.AlternateText = "Connectat";
                            }

                            cellStatus.Controls.Add(status);

                            ImageButton bt = new ImageButton();

                            bt.ID = "bt_" + service.ServiceId.ToString();
                          //  bt.PostBackUrl = GetUrlReload(_serverId, _userId, service.ServiceId.ToString(), Request.QueryString["Srv"].ToString());
                            bt.ImageUrl = "~/img/Line-chart.png";
                            bt.Click += bHardwareClick;                      

                            cellButton.Controls.Add(bt);

                            tr.Cells.Add(cellName);
                            tr.Cells.Add(cellStatus);
                            tr.Cells.Add(cellButton);

                            tableHardware.Rows.Add(tr);
                        }

                        //Memory
                        if (service.ServiceId == 102)
                        {
                            cellName.Text = service.ServiceName.Trim() + ": ";

                            Label status = new Label();
                            status.Text = 100 - service.Status + " % disponible";

                            if (service.Status > 90)
                            {
                                status.ForeColor = System.Drawing.Color.Red;
                            }
                            else
                            {
                                status.ForeColor = System.Drawing.Color.Green;
                            }

                            cellStatus.Controls.Add(status);

                            ImageButton bt = new ImageButton();

                            bt.ID = "bt_" + service.ServiceId.ToString();
                           // bt.PostBackUrl = GetUrlReload(_serverId, _userId, service.ServiceId.ToString(), Request.QueryString["Srv"].ToString());
                            bt.ImageUrl = "~/img/Line-chart.png";
                            bt.Click += bHardwareClick;

                            cellButton.Controls.Add(bt);

                            tr.Cells.Add(cellName);
                            tr.Cells.Add(cellStatus);
                            tr.Cells.Add(cellButton);

                            tableHardware.Rows.Add(tr);
                        }

                        //CPU
                        if (service.ServiceId > 102 && service.ServiceId < 107)
                        {
                            serviceCPU = "CPU";
                            if (statusCPU == 0)
                                statusCPU = service.Status;
                            else
                                statusCPU = (statusCPU + service.Status) / 2;
                        }
                        if (service.ServiceId > 106 && service.ServiceId < 111)
                        {
                            serviceHDD = "HDD";
                            maxHDD = service.MaxValue;
                            if (statusHDD == 0)
                                statusHDD = service.Status;
                            else
                                statusHDD = (statusHDD + service.Status) / 2;
                        }
                    }
                    #endregion
                }
                #endregion
                
                #region hardwarePlus

                // CPU
                if (statusCPU > 0)
                {                    
                    TableRow tr= new TableRow();

                    TableCell cellName = new TableCell();
                    TableCell cellStatus = new TableCell();
                    TableCell cellButton = new TableCell();


                    cellName.Height = 30;
                    cellName.Width = 130;
                    cellName.HorizontalAlign = HorizontalAlign.Left;

                    cellStatus.Width = 100;
                    cellStatus.HorizontalAlign = HorizontalAlign.Left;

                    cellButton.Width = 20;
                    cellButton.HorizontalAlign = HorizontalAlign.Center;

                    cellName.Text = serviceCPU.Trim() + ": ";

                    Label status = new Label();
                    status.Text = statusCPU + " % en ús";

                    if (statusCPU > 90)
                    
                        status.ForeColor = System.Drawing.Color.Red;
                    
                    else
                    
                        status.ForeColor = System.Drawing.Color.Green;
                    

                    cellStatus.Controls.Add(status);

                    ImageButton bt = new ImageButton();

                    bt.ID = "bt_103";
                   // bt.PostBackUrl = GetUrlReload(_serverId, _userId, "103", Request.QueryString["Srv"].ToString());
                    bt.ImageUrl = "~/img/Line-chart.png";
                    bt.Click += bHardwareClick;

                    cellButton.Controls.Add(bt);

                    tr.Cells.Add(cellName);
                    tr.Cells.Add(cellStatus);
                    tr.Cells.Add(cellButton);                   

                    tableHardware.Rows.Add(tr);
                }

                //  HDD
                if (statusHDD > 0)
                {            
                    TableRow tr= new TableRow();

                    TableCell cellName = new TableCell();
                    TableCell cellStatus = new TableCell();
                    TableCell cellButton = new TableCell();


                    cellName.Height = 30;
                    cellName.Width = 130;
                    cellName.HorizontalAlign = HorizontalAlign.Left;

                    cellStatus.Width = 100;
                    cellStatus.HorizontalAlign = HorizontalAlign.Left;

                    cellButton.Width = 20;
                    cellButton.HorizontalAlign = HorizontalAlign.Center;

                    cellName.Text = serviceHDD.Trim() + ": ";

                    Label status = new Label();
                    status.Text = 100 - statusHDD + " % lliure";

                    if (statusHDD > maxHDD)
                    
                        status.ForeColor = System.Drawing.Color.Red;
                    
                    else
                    
                        status.ForeColor = System.Drawing.Color.Green;
                    

                    cellStatus.Controls.Add(status);

                    ImageButton bt = new ImageButton();

                    bt.ID = "bt_107";
                    //bt.PostBackUrl = GetUrlReload(_serverId, _userId, "107", Request.QueryString["Srv"].ToString());
                    bt.ImageUrl = "~/img/Line-chart.png";
                    bt.Click += bHardwareClick;

                    cellButton.Controls.Add(bt);

                    tr.Cells.Add(cellName);
                    tr.Cells.Add(cellStatus);
                    tr.Cells.Add(cellButton);

                    tableHardware.Rows.Add(tr);
                }
                #endregion

            }
        }

        private void GenerateGraphHrd()
        {

            int serverId = Convert.ToInt32(Request.Params["Id"]);
            int serviceId = Convert.ToInt32(Request.Params["Hrd"]);

            List<ServerInfo.vHistory> historyHrd = ws.GetHistoryByServerServiceId(serverId, serviceId);

            serviceNameHrd = ws.GetService(serviceId).Name;
            timeHrd = "";
            statusSrv = "";
            serviceNameSrv = (string)Session["serviceNameSrv"];
            timeSrv = (string)Session["timeSrv"];
            statusSrv = (string)Session["statusSrv"];
            
            foreach (ServerInfo.vHistory tmp in historyHrd)
            {
                timeHrd += "'" + tmp.Instant.ToString() + "',";
                statusHrd += tmp.Value + ",";
            }

            if (historyHrd.Count > 0)
            {
                timeHrd = timeHrd.Substring(0, timeHrd.Length - 1);
                statusHrd = statusHrd.Substring(0, statusHrd.Length - 1);

                Session["serviceNameHrd"] = serviceNameHrd;
                Session["timeHrd"] = timeHrd;
                Session["statusHrd"] = statusHrd;
            }

        }

        private void GenerateGraphHrd(int _srv)
        {

            int serverId = Convert.ToInt32(Request.Params["Id"]);
            int serviceId = _srv;

            List<ServerInfo.vHistory> historyHrd = ws.GetHistoryByServerServiceId(serverId, serviceId);

            serviceNameHrd = ws.GetService(serviceId).Name;
            timeHrd = "";
            statusHrd = "";
            serviceNameSrv = (string)Session["serviceNameSrv"];
            timeSrv = (string)Session["timeSrv"];
            statusSrv = (string)Session["statusSrv"];


            foreach (ServerInfo.vHistory tmpHrd in historyHrd)
            {
                timeHrd += "'" + tmpHrd.Instant.ToString() + "',";
                statusHrd += tmpHrd.Value + ",";
            }

            if (historyHrd.Count > 0)
            {
                timeHrd = timeHrd.Substring(0, timeHrd.Length - 1);
                statusHrd = statusHrd.Substring(0, statusHrd.Length - 1);

                Session["serviceNameHrd"] = serviceNameHrd;
                Session["timeHrd"] = timeHrd;
                Session["statusHrd"] = statusHrd;
            }
        }

        private void GenerateGraphSrv()
        {
                 
            int serverId = Convert.ToInt32(Request.Params["Id"]);
            int serviceId = Convert.ToInt32(Request.Params["Srv"]);

            List<ServerInfo.vHistory> historySvr = ws.GetHistoryByServerServiceId(serverId, serviceId);

            serviceNameSrv = ws.GetService(serviceId).Name;
            timeSrv = "";
            statusSrv = "";
            serviceNameHrd = (string)Session["serviceNameHrd"];
            timeHrd = (string)Session["timeHrd"];
            statusHrd = (string)Session["statusHrd"];

            foreach (ServerInfo.vHistory tmpSrv in historySvr)
            {
                timeSrv += "'" + tmpSrv.Instant.ToString() + "',";
                statusSrv += tmpSrv.Value + ",";
            }

            if (historySvr.Count > 0)
            {
                timeSrv = timeSrv.Substring(0, timeSrv.Length - 1);
                statusSrv = statusSrv.Substring(0, statusSrv.Length - 1);

                Session["serviceNameSrv"] = serviceNameSrv;
                Session["timeSrv"] = timeSrv;
                Session["statusSrv"] = statusSrv;
            }
        }

        private void GenerateGraphSrv(int _srv)
        {

            int serverId = Convert.ToInt32(Request.Params["Id"]);
            int serviceId = _srv;

            List<ServerInfo.vHistory> historySvr = ws.GetHistoryByServerServiceId(serverId, serviceId);

            serviceNameSrv = ws.GetService(serviceId).Name;
            timeSrv = "";
            statusSrv = "";
            serviceNameHrd = (string)Session["serviceNameHrd"];
            timeHrd = (string)Session["timeHrd"];
            statusHrd = (string)Session["statusHrd"];

            foreach (ServerInfo.vHistory tmpSrv in historySvr)
            {
                timeSrv += "'" + tmpSrv.Instant.ToString() + "',";
                statusSrv += tmpSrv.Value + ",";
            }

            if (historySvr.Count > 0)
            {
                timeSrv = timeSrv.Substring(0, timeSrv.Length - 1);
                statusSrv = statusSrv.Substring(0, statusSrv.Length - 1);

                Session["serviceNameSrv"] = serviceNameSrv;
                Session["timeSrv"] = timeSrv;
                Session["statusSrv"] = statusSrv;
            }
        }

        private string GetUrlReload(int serverId, int userId, string hrd, string srv)
        {
            return "./ServerDetail.aspx?Id=" + serverId + "&userId=" + userId +
                                         "&Hrd=" + hrd + "&Srv=" + srv;
        }

        protected void bServiceClick(object sender, EventArgs e)
        {
            int service = Convert.ToInt32(((ImageButton)sender).ID.Substring(3));
            GenerateGraphSrv(service);
            UpdatePanelServiceGraph.Update();
        }

        protected void bHardwareClick(object sender, EventArgs e)
        {
            int service = Convert.ToInt32(((ImageButton)sender).ID.Substring(3));
            GenerateGraphHrd(service);
            UpdatePanelHardwareGraph.Update();
        }

    }
}