﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ServerMonitorWeb.Servers
{
    public partial class Servers : System.Web.UI.Page
    {

        ServerInfo.ServerInfoClient ws = new ServerInfo.ServerInfoClient();

        protected void Page_Load(object sender, EventArgs e)
        {
          
            if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
            {
                Response.Redirect("~/Errors/Error.aspx");
            }
            
            List<ServerInfo.vServers> servers = ws.GetServersByUserId(Convert.ToInt32(Session["UserId"].ToString()));
            
            GridViewServers.DataSource = servers;
            GridViewServers.DataBind();


            Session["serviceNameHrd"] = "";
            Session["timeHrd"] = "";
            Session["statusHrd"] = "";
            Session["serviceNameSrv"] = "";
            Session["timeSrv"] = "";
            Session["statusSrv"] = "";

            if (!Page.IsPostBack)
            {
                if (!Page.IsPostBack)
                {
                    ws.InsertAccessLog((int)Session["UserId"], "Entrada a la pàgina del servidors");
                }
            }
        }

        protected void GridViewServers_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {

                ServerInfo.vServers server = e.Row.DataItem as ServerInfo.vServers;

         // Status
                ImageButton image = new ImageButton();

                if (server.Status == 0)
                {
                    image.AlternateText = "Caigut";
                    image.ImageUrl = "~/img/server-ko.png";
                }
                else
                {
                    image.AlternateText = "OnLine";
                    image.ImageUrl = "~/img/server-ok.png";
                }

                image.PostBackUrl = "./ServerDetail.aspx?Id=" + server.Id.ToString() +
                                    "&userId=" + Session["UserId"].ToString() + "&Hrd=0&Srv=0";

                image.ImageAlign = ImageAlign.Middle;
                image.Width = 20;
                image.Height = 20;

                e.Row.Cells[1].Controls.Add(image);

         // ServerName

                HyperLink servername = new HyperLink();

                servername.Text = server.Name;
                servername.NavigateUrl = "./ServerDetail.aspx?Id=" + server.Id.ToString() +
                                         "&userId=" + Session["UserId"].ToString() +
                                         "&Hrd=0&Srv=0";

                e.Row.Cells[2].Controls.Add(servername);

         // Critic

                if (server.Critic)
                {
                    Image critic = new Image();
                    critic.AlternateText = "Critic";
                    critic.ImageUrl = "~/img/warning.png";

                    critic.ImageAlign = ImageAlign.Middle;
                    critic.Width = 20;
                    critic.Height = 20;

                    e.Row.Cells[4].Controls.Add(critic);
                }
                else
                {
                    e.Row.Cells[4].Text = "";
                }

          // LastAlarm

                if (server.LastAlarm.Equals(new DateTime(0)))
                {
                    e.Row.Cells[7].Text = "Mai";
                }

            }
        }

        protected void GViewServers_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            this.GridViewServers.PageIndex = e.NewPageIndex;
            this.GridViewServers.DataBind();         
        }

    }
}