﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ServerMonitorWeb
{
    public partial class SiteMaster : System.Web.UI.MasterPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            
            if (Session["UserLogged"] == null || Session["UserLogged"] == "false")
            {
                hlUserLogged.Text = "Iniciar sessió";
                hlUserLogged.NavigateUrl = "Account/Login.aspx";
                NavigationMenu.Visible = false;             
            }
            else
            {
                hlUserLogged.Text = Session["UserName"].ToString();
                hlUserLogged.NavigateUrl = "Account/EditProfile.aspx";
                hlLogOff.Text = "(Sortir)";
                lbSeparator.Text = "-";
                hlLogOff.NavigateUrl = "Account/LogOff.aspx";
                hlLogOff.Width = 50;
                NavigationMenu.Visible = true;                
                GenerateMenu(Session["UserGroupId"].ToString());
            }
            lbfoot.Text = DateTime.Now.ToString();
        }

        private void GenerateMenu(string _group)
        {
            MenuItem itemDefault = new MenuItem("Pàgina principal", "", "", "~/Default.aspx");
            MenuItem itemAlerts = new MenuItem("Alertes", "", "", "~/Alerts/Alerts.aspx");
            MenuItem itemServers = new MenuItem("Servidors", "", "", "~/Servers/Servers.aspx");
            MenuItem itemConfig = new MenuItem("Configuració");
            MenuItem itemConfigUsers= new MenuItem("Usuaris", "", "", "~/Config/Users/ConfigUsers.aspx");
            MenuItem itemConfigServers= new MenuItem("Servidors", "", "", "~/Config/Servers/ConfigServers.aspx");
            MenuItem itemConfigAlerts= new MenuItem("Alertes", "", "", "~/Config/Alerts/ConfigAlerts.aspx");
            MenuItem itemConfigApp= new MenuItem("Aplicació", "", "", "~/Config/App/ConfigApp.aspx");

                itemConfig.ChildItems.Add(itemConfigUsers);
                itemConfig.ChildItems.Add(itemConfigServers);
                itemConfig.ChildItems.Add(itemConfigAlerts);
                itemConfig.ChildItems.Add(itemConfigApp);

            MenuItem itemHelp = new MenuItem("Ajuda");
            MenuItem itemManual= new MenuItem("Manual", "", "", "~/Manual/Manual.aspx", "_blank");
            MenuItem itemAbout= new MenuItem("A sobre de", "", "", "~/About.aspx");

            itemHelp.ChildItems.Add(itemManual);
            itemHelp.ChildItems.Add(itemAbout);

            NavigationMenu.Items.Add(itemDefault);
            NavigationMenu.Items.Add(itemAlerts);
            NavigationMenu.Items.Add(itemServers);

            if (_group.Equals("1"))
            {
                NavigationMenu.Items.Add(itemConfig);
            }
            NavigationMenu.Items.Add(itemHelp);
        }
    }
}
